#define D3D_OVERLOADS
#include "btkclass.h"
#include "render.h"
#include "engine.h"
#include "Utils\d3dmath.h"
#include "input.h"
#include "dplay\comm.h"
#include "dplay\wizard.h"
#include "dplay\vsichni.h"

int AmmoLimit[4][2]={//kolik jake vozitko uveze munice
{30,0},{80,0},{40,6},{20,40}
};

float FuelLimit[4]={//kolik jake vozitko uveze paliva
20.0f,80.0f,40.0f,50.0f
//0.5f,1.0f,0.75f,1.0f
};

int DamageLimit[4]={//kolik jake vozitko snese zasahu
0,30,30,10
};

int SilaStrely[4]={//kolik jaka strela ubere z limitu damage auta
1,2,1,3//posledni je mina
};


char *LoadTexPath=".\\";

HRESULT TXStatic::Load(char *filename)
	{
	if(!Objekt3D)
		return E_FAIL;
	return Objekt3D->Load(filename);
	}

HRESULT TXStatic::Display(LPDIRECT3DDEVICE3 pd3dDevice,float x,float y,float r,DWORD time)//zobrazi objekt na x,y,rotace (z=0 default
{
D3DMATRIX matRotat;
D3DMATRIX matTrans;
D3DUtil_SetRotateYMatrix(matRotat,r);
D3DUtil_SetTranslateMatrix(matTrans,x,0,-y);
D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);
if(Objekt3D)
	return Objekt3D->Render(pd3dDevice,g_pmtrlObjectMtrl);
return E_FAIL;
} 

HRESULT TTStatic::Load(char *filename,DWORD dwFlags)
	{
	TexData=MyTextr_CreateTexture(TEXT(filename),0,dwFlags);
	if(!TexData)
		return E_FAIL;
	return S_OK;
	}

void TTStatic::Restore(LPDIRECT3DDEVICE3 pd3dDevice )
	{
	MyTextr_Restore(TexData, pd3dDevice );
	}

void TTStatic::Invalidate()
	{
	MyTextr_Invalidate(TexData);
	}

HRESULT TTStatic::Display(LPDIRECT3DDEVICE3 pd3dDevice,float x,float y,float r,DWORD time)//zobrazi objekt na x,y,rotace (z=0 default
{
D3DMATRIX matRotat;
D3DMATRIX matTrans;
D3DUtil_SetRotateYMatrix(matRotat,r);
D3DUtil_SetTranslateMatrix(matTrans,x,0,-y);
D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);

D3DVERTEX Policko[4];
Policko[0]=D3DVERTEX(D3DVECTOR(-ScaleX,0,ScaleY),D3DVECTOR(0,1,0),0,0);
Policko[1]=D3DVERTEX(D3DVECTOR(ScaleX,0,ScaleY),D3DVECTOR(0,1,0),1,0);
Policko[2]=D3DVERTEX(D3DVECTOR(-ScaleX,0,-ScaleY),D3DVECTOR(0,1,0),0,1);
Policko[3]=D3DVERTEX(D3DVECTOR(ScaleX,0,-ScaleY),D3DVECTOR(0,1,0),1,1);

/*pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );*/
pd3dDevice->SetTextureStageState( 0, D3DTSS_MINFILTER, D3DTFN_LINEAR );
pd3dDevice->SetTextureStageState( 0, D3DTSS_MAGFILTER, D3DTFG_LINEAR );
pd3dDevice->SetRenderState( D3DRENDERSTATE_DITHERENABLE, TRUE );
//pd3dDevice->SetRenderState( D3DRENDERSTATE_SPECULARENABLE, TRUE );

/*	pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE,  FALSE );

	// Set state for rendering shadows
//	pd3dDevice->SetTexture( 0, D3DTextr_GetTexture("Shadow1.bmp") );
	pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHABLENDENABLE,   TRUE );

	// Enable alpha blending using the texture's alpha channel
	pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1 );
	pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE );

	// Turn on alpha testing in case the device supports it. (This is a 
	// performance boost to avoid drawing pixels with less than a certain
	// alpha.)
	if( g_bDeviceDoesAlphaTest )
	{//pokus
		pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE, TRUE );
		pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHAREF,        0x08 );
		pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHAFUNC, D3DCMP_GREATEREQUAL );
	}

	// Set state for drawing trees. Note that many states that were set for
	// rendering shadows are kept for rendering the trees.
//	pd3dDevice->SetRenderState( D3DRENDERSTATE_TEXTUREPERSPECTIVE, FALSE );

	// Set diffuse blending for alpha set in vertices. 
	pd3dDevice->SetRenderState( D3DRENDERSTATE_SRCBLEND,  D3DBLEND_SRCALPHA );
	pd3dDevice->SetRenderState( D3DRENDERSTATE_DESTBLEND, D3DBLEND_INVSRCALPHA );
	pd3dDevice->SetRenderState( D3DRENDERSTATE_COLORKEYENABLE , TRUE );*/

	pd3dDevice->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE,TRUE);//pokus
//	pd3dDevice->SetRenderState(D3DRENDERSTATE_ZENABLE,D3DZB_FALSE );//pokus
//the D3DRENDERSTATE_ZFUNC, 

pd3dDevice->SetTexture(0,TexData->ptexTexture);
pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,Policko,4,0/*D3DDP_WAIT*/);

//	pd3dDevice->SetRenderState(D3DRENDERSTATE_ZENABLE,D3DZB_TRUE );//pokus
	pd3dDevice->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE,FALSE);//pokus
return S_OK;
} 

TMapka::TMapka(int x,int y)
	{
	SizeX=0;
	SizeY=0;
	Mapa=new TPole[x*y];
	if(Mapa)
		{
		SizeX=x;
		SizeY=y;
		for(int i=0;i<x*y;i++)
			{
			Mapa[i].Podklad=0;
			Mapa[i].Spojak=new TSpojak <TStatSpoj>;
			}
		}
	}

TMapka::~TMapka()
	{
	if(Mapa)
		{
		for(int i=0;i<SizeX*SizeY;i++)
			{//pres celou mapku
			SAFE_DELETE(Mapa[i].Spojak);
			}
		delete Mapa;
		}
	}

/**************TEXTURY*******************************/

TexCont::~TexCont()
{
    SAFE_RELEASE( ptexTexture );
    SAFE_RELEASE( pddsSurface );
    DeleteObject( hbmBitmap );
}

TexCont *MyTextr_CreateTexture( TCHAR* strName, DWORD dwStage, DWORD dwFlags )
{
    TexCont* ptcTexture = new TexCont();
    if( NULL == ptcTexture )
        return NULL;
    ZeroMemory( ptcTexture, sizeof(TexCont) );
    lstrcpy( ptcTexture->strName, strName );
    ptcTexture->dwStage = dwStage;
    ptcTexture->dwFlags = dwFlags;

    // Create a bitmap and load the texture file into it,
    if( FAILED( MyLoadTextureImage( ptcTexture ) ) )
    {
        delete ptcTexture;
        return NULL;
    }

    return ptcTexture;
}

HRESULT MyFindTextureFile( TCHAR* strFilename, TCHAR* strAddr,
                         TCHAR* strFullPath )
{
    _stprintf( strFullPath, TEXT("%s\\%s"), strAddr, strFilename );
    if( FileExists( strFullPath ) )
        return DD_OK;

    return DDERR_NOTFOUND;
}

HRESULT MyLoadTextureImage( TexCont* ptcTexture )
{
    TCHAR* strFilename = ptcTexture->strName;
    TCHAR* strExtension;
    TCHAR  strPathname[256];

    // Get the filename extension
    if( NULL == ( strExtension = _tcsrchr( strFilename, TEXT('.') ) ) )
        return DDERR_UNSUPPORTED;

    // Check the executable's resource. If it's there, we're done!
    if( NULL != ( ptcTexture->hbmBitmap = (HBITMAP)LoadImage(
                                            GetModuleHandle(NULL),
                                            strFilename, IMAGE_BITMAP,
                                            0, 0, LR_CREATEDIBSECTION) ) )
        return S_OK;

    if( FAILED( MyFindTextureFile( strFilename, TEXT(LoadTexPath), strPathname ) ) )
        return DDERR_NOTFOUND;

    if( !lstrcmpi( strExtension, ".bmp" ) )
    {
        // Try to load the bitmap as a resource.
        ptcTexture->hbmBitmap = (HBITMAP)LoadImage( GetModuleHandle(NULL),
                                        strPathname, IMAGE_BITMAP, 0, 0, 
                                        LR_CREATEDIBSECTION );

        // If the bitmap wasn't a resource, try it as a file.
        if( NULL == ptcTexture->hbmBitmap )
            ptcTexture->hbmBitmap = (HBITMAP)LoadImage( NULL, strPathname,
                                        IMAGE_BITMAP, 0, 0, 
                                        LR_LOADFROMFILE|LR_CREATEDIBSECTION );

        return (ptcTexture->hbmBitmap) ? DD_OK : DDERR_NOTFOUND;
    }

    // Can check for other file formats here

    return DDERR_UNSUPPORTED;
}

HRESULT MyTextr_Invalidate(TexCont* ptcTexture)
{
    SAFE_RELEASE( ptcTexture->ptexTexture );
    SAFE_RELEASE( ptcTexture->pddsSurface );
    return S_OK;
}

HRESULT MyTextr_Restore( TexCont* ptcTexture, LPDIRECT3DDEVICE3 pd3dDevice )
{
    // Check params
    if( NULL == pd3dDevice )
        return DDERR_INVALIDPARAMS;
    if( NULL == ptcTexture )
        return DDERR_NOTFOUND;

    // Release any previously created objects
    SAFE_RELEASE( ptcTexture->ptexTexture );
    SAFE_RELEASE( ptcTexture->pddsSurface );

    // Get the DirectDraw interface for creating surfaces
    LPDIRECTDRAW4 pDD;
    if( NULL == ( pDD = D3DUtil_GetDirectDrawFromDevice( pd3dDevice ) ) )
        return E_FAIL;
    pDD->Release();

    // Get the device caps
    D3DDEVICEDESC ddHwDesc, ddSwDesc;
    DWORD         dwDeviceCaps;
    ddHwDesc.dwSize = sizeof(D3DDEVICEDESC);
    ddSwDesc.dwSize = sizeof(D3DDEVICEDESC);
    if( FAILED( pd3dDevice->GetCaps( &ddHwDesc, &ddSwDesc ) ) )
        return E_FAIL;
    if( ddHwDesc.dwFlags ) dwDeviceCaps = ddHwDesc.dpcTriCaps.dwTextureCaps;
    else                   dwDeviceCaps = ddSwDesc.dpcTriCaps.dwTextureCaps;

    // Get the bitmap structure (to extract width, height, and bpp)
    BITMAP bm;
    HBITMAP hbmBitmap = ptcTexture->hbmBitmap;
    GetObject( hbmBitmap, sizeof(BITMAP), &bm );
    DWORD dwWidth  = (DWORD)bm.bmWidth;
    DWORD dwHeight = (DWORD)bm.bmHeight;

    // Setup the new surface desc
    DDSURFACEDESC2 ddsd;
    D3DUtil_InitSurfaceDesc( ddsd );
    ddsd.dwFlags         = DDSD_CAPS|DDSD_HEIGHT|DDSD_WIDTH|
                           DDSD_PIXELFORMAT|DDSD_TEXTURESTAGE;
	if(ptcTexture->dwFlags&DDSD_CKSRCBLT)
		{
		ddsd.dwFlags|=DDSD_CKSRCBLT;//nove
		}
    ddsd.ddsCaps.dwCaps  = DDSCAPS_TEXTURE;
    ddsd.ddsCaps.dwCaps2 = DDSCAPS2_TEXTUREMANAGE;
    ddsd.dwTextureStage  = ptcTexture->dwStage;
    ddsd.dwWidth         = dwWidth;
    ddsd.dwHeight        = dwHeight;

    // Adjust width and height, if the driver requires it
    if( dwDeviceCaps & D3DPTEXTURECAPS_POW2 )
    {
        for( ddsd.dwWidth=1;  dwWidth>ddsd.dwWidth;   ddsd.dwWidth<<=1 );
        for( ddsd.dwHeight=1; dwHeight>ddsd.dwHeight; ddsd.dwHeight<<=1 );
    }
    if( dwDeviceCaps & D3DPTEXTURECAPS_SQUAREONLY )
    {
        if( ddsd.dwWidth > ddsd.dwHeight ) ddsd.dwHeight = ddsd.dwWidth;
        else                               ddsd.dwWidth  = ddsd.dwHeight;
    }

    BOOL bUsePalette  = ( bm.bmBitsPixel <= 8 );
    BOOL bUseAlpha    = FALSE;
    BOOL bOneBitAlpha = FALSE;

    if( ptcTexture->bHasAlpha )
        bUseAlpha = TRUE;
    
    if( ptcTexture->dwFlags & (D3DTEXTR_TRANSPARENTWHITE|D3DTEXTR_TRANSPARENTBLACK) )
    {
        if( bUsePalette )
        {
            bUseAlpha    = TRUE;
            bOneBitAlpha = TRUE;

            if( dwDeviceCaps & D3DPTEXTURECAPS_ALPHAPALETTE )
                bUsePalette = TRUE;
            else
                bUsePalette = FALSE;
        }
    }

    // Setup the structure to be used for texture enumration.
    TEXTURESEARCHINFO tsi;
    tsi.pddpf            = &ddsd.ddpfPixelFormat;
    tsi.bUseAlpha        = bUseAlpha;
    tsi.bOneBitAlpha     = bOneBitAlpha;
    tsi.bUsePalette      = bUsePalette;
    tsi.bFoundGoodFormat = FALSE;

    if( ptcTexture->dwFlags & D3DTEXTR_32BITSPERPIXEL )
        tsi.dwBPP = 32;
    else
        tsi.dwBPP = 16;

    // Enumerate the texture formats, and find the closest device-supported
    // texture pixel format
    pd3dDevice->EnumTextureFormats( TextureSearchCallback, &tsi );

    // If a palettized format was requested, but not found, default to a
    // 16-bit texture format
    if( FALSE == tsi.bFoundGoodFormat && bUsePalette )
    {
        tsi.bUsePalette = FALSE;
        tsi.dwBPP       = 16;
        pd3dDevice->EnumTextureFormats( TextureSearchCallback, &tsi );
    }

    // We must fail if we can't find a good format
    if( FALSE == tsi.bFoundGoodFormat )
        return E_FAIL;
    
    // Create a new surface for the texture
    HRESULT hr;
/*	if(ddsd.dwFlags&DDSD_CKSRCBLT)
		{
		int h=0;
		h++;h--;
		}*///pokus
    if( FAILED( hr = pDD->CreateSurface( &ddsd, &ptcTexture->pddsSurface, NULL ) ) )
        return E_FAIL;

    // Create the texture
    if( FAILED( ptcTexture->pddsSurface->QueryInterface( IID_IDirect3DTexture2,
                                         (VOID**)&ptcTexture->ptexTexture ) ) )
        return E_FAIL;


    // Copy the bitmap to the texture surface
    return CopyBitmapToSurface( ptcTexture->pddsSurface, hbmBitmap,ptcTexture->dwFlags );
}   


/*************prostredky**************************/

HRESULT TJeep::Hit(TStrela *strela)
{
if(strela->Vyska==1)//vzdusna
	return E_FAIL;//nezasahla
/*if(_hypot((float)(strela->X-share->X),(float)(strela->Y-share->Y))<0.25)//upravit
	{
	return S_OK;
	}*///zastarale
float obx[4];
float oby[4];
float sinR=(float)sin(share->R);
float cosR=(float)cos(share->R);
for(int i=0;i<4;i++)
	{//otocime obrys podle auta a posuneme podle polohy auta
	obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR;
	oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR;
	obx[i]+=share->X;
	oby[i]+=share->Y;//podle skutecnych a ne podle 'deSync'!!!
	}
if(Uvnitr(obx,oby,strela->X,strela->Y))
	return S_OK;//zasah
return E_FAIL;
}

HRESULT TJeep::Display(LPDIRECT3DDEVICE3 pd3dDevice,DWORD time)
{
CompDeSync();

D3DMATRIX matRotat;
D3DMATRIX matTrans;
D3DUtil_SetRotateYMatrix(matRotat,deR-g_PI_DIV_2);
if(zoom)
	{
	D3DUtil_SetScaleMatrix(matTrans,zoom,zoom,zoom);
	D3DMath_MatrixMultiply(matRotat,matTrans,matRotat);
	}
D3DUtil_SetTranslateMatrix(matTrans,deX,share->Z+(float)sin(share->RVrt1)*0.2f*(float)fabs(share->Z),-deY);
D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);

//kvuli modelum z 3DStudia
pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_NONE);//aby to zobrazovalo nepovedene modely s 3dstudia

if(AutoModely)
	{
	HRESULT hr=AutoModely[0].Render(pd3dDevice,g_pmtrlObjectMtrl);
	if(FAILED(hr))
		return hr;
	pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_CCW);//higher performance
	
	if(share->Vlajecka)
		{
		//ted vlajecky
		D3DUtil_SetTranslateMatrix(matRotat,0,0.3f,0);
		D3DMath_MatrixMultiply(matTrans,matRotat,matTrans);
		pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);
		if(EngDruzstvo==share->byType)
			hr=VlajModely[0].Render(pd3dDevice,g_pmtrlObjectMtrl);//dodelat
		else
			hr=VlajModely[1].Render(pd3dDevice,g_pmtrlObjectMtrl);//dodelat
		}
	return hr;
	}
return E_FAIL;//casem se rozanimuje
}

HRESULT TTank::Hit(TStrela *strela)
{
if(strela->Vyska==1)//vzdusna
	return E_FAIL;//nezasahla
float obx[4];
float oby[4];
float sinR=(float)sin(share->R);
float cosR=(float)cos(share->R);
for(int i=0;i<4;i++)
	{//otocime obrys podle auta a posuneme podle polohy auta
	obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR;
	oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR;
	obx[i]+=share->X;
	oby[i]+=share->Y;//podle skutecnych a ne podle 'deSync'!!!
	}
if(Uvnitr(obx,oby,strela->X,strela->Y))
	return S_OK;//zasah
return E_FAIL;
}

HRESULT TTank::Display(LPDIRECT3DDEVICE3 pd3dDevice,DWORD time)
{
CompDeSync();

D3DMATRIX matRotat;
D3DMATRIX matTrans;
D3DUtil_SetRotateYMatrix(matRotat,deR+g_PI_DIV_2);
if(zoom)
	{
	D3DUtil_SetScaleMatrix(matTrans,zoom,zoom,zoom);
	D3DMath_MatrixMultiply(matRotat,matTrans,matRotat);
	}
D3DUtil_SetTranslateMatrix(matTrans,deX,share->Z,-deY);
D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);

//kvuli modelum z 3DStudia
pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_NONE);//aby to zobrazovalo nepovedene modely s 3dstudia

if(AutoModely)
	{
	HRESULT hr=AutoModely[1].Render(pd3dDevice,g_pmtrlObjectMtrl);

	if(FAILED(hr))
		return hr;

	D3DUtil_SetRotateYMatrix(matRotat,deR+g_PI_DIV_2+share->RHlav);//nastav trans. pro hlaven
	if(zoom)
		{
		D3DUtil_SetScaleMatrix(matTrans,zoom,zoom,zoom);
		D3DMath_MatrixMultiply(matRotat,matTrans,matRotat);
		}
	D3DUtil_SetTranslateMatrix(matTrans,deX,share->Z,-deY);
	D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
	pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);

	hr=AutoModely[4].Render(pd3dDevice,g_pmtrlObjectMtrl);//render hlaven

	pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_CCW);//higher performance
	return hr;
	}
return E_FAIL;//casem se rozanimuje
}

HRESULT TArmo::Hit(TStrela *strela)
{
if(strela->Vyska==1)//vzdusna
	return E_FAIL;//nezasahla
float obx[4];
float oby[4];
float sinR=(float)sin(share->R);
float cosR=(float)cos(share->R);
for(int i=0;i<4;i++)
	{//otocime obrys podle auta a posuneme podle polohy auta
	obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR;
	oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR;
	obx[i]+=share->X;
	oby[i]+=share->Y;//podle skutecnych a ne podle 'deSync'!!!
	}
if(Uvnitr(obx,oby,strela->X,strela->Y))
	return S_OK;//zasah
return E_FAIL;
}

HRESULT TArmo::Display(LPDIRECT3DDEVICE3 pd3dDevice,DWORD time)
{
CompDeSync();

D3DMATRIX matRotat;
D3DMATRIX matTrans;
D3DUtil_SetRotateYMatrix(matRotat,deR-g_PI_DIV_2);
if(zoom)
	{
	D3DUtil_SetScaleMatrix(matTrans,zoom,zoom,zoom);
	D3DMath_MatrixMultiply(matRotat,matTrans,matRotat);
	}
D3DUtil_SetTranslateMatrix(matTrans,deX,share->Z,-deY);
D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);

//kvuli modelum z 3DStudia
pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_NONE);//aby to zobrazovalo nepovedene modely s 3dstudia

if(AutoModely)
	{
	HRESULT hr=AutoModely[2].Render(pd3dDevice,g_pmtrlObjectMtrl);
	pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_CCW);//higher performance
	return hr;
	}
return E_FAIL;//casem se rozanimuje
}

HRESULT THeli::Hit(TStrela *strela)
{
if(strela->Vyska==0)//vzdusna
	return E_FAIL;//nezasahla
float obx[4];
float oby[4];
float sinR=(float)sin(share->R);
float cosR=(float)cos(share->R);
for(int i=0;i<4;i++)
	{//otocime obrys podle auta a posuneme podle polohy auta
	obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR;
	oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR;
	obx[i]+=share->X;
	oby[i]+=share->Y;//podle skutecnych a ne podle 'deSync'!!!
	}
if(Uvnitr(obx,oby,strela->X,strela->Y))
	return S_OK;//zasah
return E_FAIL;
}

HRESULT THeli::Display(LPDIRECT3DDEVICE3 pd3dDevice,DWORD time)
{
CompDeSync();

D3DMATRIX matRotat;
D3DMATRIX matTrans;
D3DUtil_SetRotateYMatrix(matRotat,deR+g_PI_DIV_2);
if(zoom)
	{
	D3DUtil_SetScaleMatrix(matTrans,zoom,zoom,zoom);
	D3DMath_MatrixMultiply(matRotat,matTrans,matRotat);
	}
D3DUtil_SetTranslateMatrix(matTrans,deX,share->Z,-deY);
D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);

//kvuli modelum z 3DStudia
pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_NONE);//aby to zobrazovalo nepovedene modely s 3dstudia

if(AutoModely)
	{
	HRESULT hr=AutoModely[3].Render(pd3dDevice,g_pmtrlObjectMtrl);

	if(FAILED(hr))
		return hr;

	D3DUtil_SetRotateYMatrix(matRotat,share->RVrt1);
	if(zoom)
		{
		D3DUtil_SetScaleMatrix(matTrans,zoom,zoom,zoom);
		D3DMath_MatrixMultiply(matRotat,matTrans,matRotat);
		}
	D3DUtil_SetTranslateMatrix(matTrans,deX,share->Z,-deY);
	D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
	pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);
	hr=AutoModely[5].Render(pd3dDevice,g_pmtrlObjectMtrl);//1.vrtule

	D3DUtil_SetRotateYMatrix(matRotat,share->RVrt2);
	if(zoom)
		{
		D3DUtil_SetScaleMatrix(matTrans,zoom,zoom,zoom);
		D3DMath_MatrixMultiply(matRotat,matTrans,matRotat);
		}
	D3DUtil_SetTranslateMatrix(matTrans,deX,share->Z,-deY);
	D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
	pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);
	hr=AutoModely[6].Render(pd3dDevice,g_pmtrlObjectMtrl);//1.vrtule

	pd3dDevice->SetRenderState(D3DRENDERSTATE_CULLMODE,D3DCULL_CCW);//higher performance
	return hr;
	}
return E_FAIL;//casem se rozanimuje
}

HRESULT TJeep::Kolize(TStatSpoj *stat,float mx,float my)
{
TStatic *pom;
pom=EngStatic[stat->Index];
if(!pom)//tohle by se nemelo stavat (slepe odkazy v mapce!)
	return E_FAIL;
if(pom->typ==TYP_BUDOVA)//zde je treba pouzit specialni postup
	{
	float obx[4];
	float oby[4];
	float sinR=(float)sin(share->R);
	float cosR=(float)cos(share->R);
	for(int i=0;i<4;i++)
		{//otocime obrys podle auta a posuneme podle polohy auta vuci budove
		obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR;
		oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR;
		obx[i]+=share->X-mx-stat->X;
		oby[i]+=share->Y-my-stat->Y;
		}
	sinR=(float)sin(-stat->R);
	cosR=(float)cos(-stat->R);//ted otocime vuci budove
	float obxi;
	for(i=0;i<4;i++)
		{//otocime obrys podle auta a posuneme podle polohy auta vuci budove
		obxi=obx[i];
		obx[i]=obx[i]*cosR-oby[i]*sinR;
		oby[i]=oby[i]*cosR+obxi*sinR;
		}
	//ted mame vsechny vrcholy obrysu auta relativne vuci neotocenemu obrysu budovy
	if(SUCCEEDED(((TBudova *)pom)->Kolize(obx,oby)))
		{
		if(pom->pojede[0])//znamena zda jeep projede touto prekazkou ci ne
			return S_OK;//projedu
		return E_ACCESSDENIED;//neprojedu
		}
	}//casem mozna predelat, ze budu volat pouze kolize pro staticke objekty a jako parametr davat vozidlo
else
	{//predelat (obrys jeepu)
	if(pom->range==0.0)
		return E_FAIL;//nekoliduje s nicim	
	float gx=mx+stat->X-share->X;
	float gy=my+stat->Y-share->Y;//poloha vuci jeepu
	float ngx;
	float ngy;//nova gx a gy otocena podle auta
	float sinR=(float)sin(-share->R);
	float cosR=(float)cos(-share->R);
	ngx=gx*cosR-gy*sinR;
	ngy=gy*cosR+gx*sinR;
	//ted mame v ngx a ngy sour stat. relativne vuci obrysu auta
	for(int i=0;i<4;i++)
		{
		if(_hypot(ObrysX[i]-ngx,ObrysY[i]-ngy)<pom->range)
			{
			if(pom->pojede[0])//znamena zda jeep projede touto prekazkou ci ne
				return S_OK;//projedu
			return E_ACCESSDENIED;//neprojedu
			}
		}//vrcholy nezasahuji -> pocitej dal
	for(i=0;i<4;i++)
		{//pres vsechny hrany
		gx=-ObrysX[i]+ObrysX[(i+1)%4];
		gy=-ObrysY[i]+ObrysY[(i+1)%4];
		float t=(gx*(ObrysX[i]-ngx)-gy*(ObrysY[i]-ngy))/(gy*gy-gx*gx);
		if(t>0&&t<1)
			{//teoreticky muze zasahovat do hrany aniz zasahuje do vrcholu
			if(_hypot(ObrysX[i]+t*gx-ngx,ObrysY[i]+t*gy-ngy)<pom->range)
				{
				if(pom->pojede[0])//znamena zda jeep projede touto prekazkou ci ne
					return S_OK;//projedu
				return E_ACCESSDENIED;//neprojedu
				}
			}
		}
	}
return E_FAIL;
}

HRESULT TJeep::Kolize(TCar *car)
{//zjisti zda koliduji s jinym autem
if(car->Typ==3)
	return E_FAIL;//s vrtulnikem se proste nesrazim
float obx[4];
float oby[4];
float obx2[4];
float oby2[4];
float sinR=(float)sin(share->R);
float cosR=(float)cos(share->R);
for(int i=0;i<4;i++)
	{//vypocteme absolutni souradnice obrysu tohoto auta
	obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR+share->X;
	oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR+share->Y;
	}
sinR=(float)sin(car->share->R);
cosR=(float)cos(car->share->R);
for(i=0;i<4;i++)
	{//vypocteme absolutni souradnice obrysu druheho auta
	obx2[i]=car->ObrysX[i]*cosR-car->ObrysY[i]*sinR+car->share->X;
	oby2[i]=car->ObrysY[i]*cosR+car->ObrysX[i]*sinR+car->share->Y;
	}
if(Prekryv(obx,oby,obx2,oby2))
	return S_OK;//kolize
return E_FAIL;
}

HRESULT TTank::Kolize(TStatSpoj *stat,float mx,float my)
{
TStatic *pom;
pom=EngStatic[stat->Index];
if(!pom)//tohle by se nemelo stavat (slepe odkazy v mapce!)
	return E_FAIL;
if(pom->typ==TYP_BUDOVA)//zde je treba pouzit specialni postup
	{
	float obx[4];
	float oby[4];
	float sinR=(float)sin(share->R);
	float cosR=(float)cos(share->R);
	for(int i=0;i<4;i++)
		{//otocime obrys podle auta a posuneme podle polohy auta vuci budove
		obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR;
		oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR;
		obx[i]+=share->X-mx-stat->X;
		oby[i]+=share->Y-my-stat->Y;
		}
	sinR=(float)sin(-stat->R);
	cosR=(float)cos(-stat->R);//ted otocime vuci budove
	float obxi;
	for(i=0;i<4;i++)
		{//otocime obrys podle auta a posuneme podle polohy auta vuci budove
		obxi=obx[i];
		obx[i]=obx[i]*cosR-oby[i]*sinR;
		oby[i]=oby[i]*cosR+obxi*sinR;
		}
	//ted mame vsechny vrcholy obrysu auta relativne vuci neotocenemu obrysu budovy
	if(SUCCEEDED(((TBudova *)pom)->Kolize(obx,oby)))
		{
		if(pom->pojede[1])//znamena zda jeep projede touto prekazkou ci ne
			return S_OK;//projedu
		return E_ACCESSDENIED;//neprojedu
		}
	}//casem mozna predelat, ze budu volat pouze kolize pro staticke objekty a jako parametr davat vozidlo
else
	{//predelat (obrys jeepu)
	if(pom->range==0.0)
		return E_FAIL;//nekoliduje s nicim	
	float gx=mx+stat->X-share->X;
	float gy=my+stat->Y-share->Y;//poloha vuci jeepu
	float ngx;
	float ngy;//nova gx a gy otocena podle auta
	float sinR=(float)sin(-share->R);
	float cosR=(float)cos(-share->R);
	ngx=gx*cosR-gy*sinR;
	ngy=gy*cosR+gx*sinR;
	//ted mame v ngx a ngy sour stat. relativne vuci obrysu auta
	for(int i=0;i<4;i++)
		{
		if(_hypot(ObrysX[i]-ngx,ObrysY[i]-ngy)<pom->range)
			{
			if(pom->pojede[1])//znamena zda jeep projede touto prekazkou ci ne
				return S_OK;//projedu
			return E_ACCESSDENIED;//neprojedu
			}
		}//vrcholy nezasahuji -> pocitej dal
	for(i=0;i<4;i++)
		{//pres vsechny hrany
		gx=-ObrysX[i]+ObrysX[(i+1)%4];
		gy=-ObrysY[i]+ObrysY[(i+1)%4];
		float t=(gx*(ObrysX[i]-ngx)-gy*(ObrysY[i]-ngy))/(gy*gy-gx*gx);
		if(t>0&&t<1)
			{//teoreticky muze zasahovat do hrany aniz zasahuje do vrcholu
			if(_hypot(ObrysX[i]+t*gx-ngx,ObrysY[i]+t*gy-ngy)<pom->range)
				{
				if(pom->pojede[1])//znamena zda jeep projede touto prekazkou ci ne
					return S_OK;//projedu
				return E_ACCESSDENIED;//neprojedu
				}
			}
		}
	}
return E_FAIL;
}

HRESULT TTank::Kolize(TCar *car)
{//zjisti zda koliduji s jinym autem
if(car->Typ==3)
	return E_FAIL;//s vrtulnikem se proste nesrazim
float obx[4];
float oby[4];
float obx2[4];
float oby2[4];
float sinR=(float)sin(share->R);
float cosR=(float)cos(share->R);
for(int i=0;i<4;i++)
	{//vypocteme absolutni souradnice obrysu tohoto auta
	obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR+share->X;
	oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR+share->Y;
	}
sinR=(float)sin(car->share->R);
cosR=(float)cos(car->share->R);
for(i=0;i<4;i++)
	{//vypocteme absolutni souradnice obrysu druheho auta
	obx2[i]=car->ObrysX[i]*cosR-car->ObrysY[i]*sinR+car->share->X;
	oby2[i]=car->ObrysY[i]*cosR+car->ObrysX[i]*sinR+car->share->Y;
	}
if(Prekryv(obx,oby,obx2,oby2))
	return S_OK;//kolize
return E_FAIL;
}

HRESULT TArmo::Kolize(TStatSpoj *stat,float mx,float my)
{
TStatic *pom;
pom=EngStatic[stat->Index];
if(!pom)//tohle by se nemelo stavat (slepe odkazy v mapce!)
	return E_FAIL;
if(pom->typ==TYP_BUDOVA)//zde je treba pouzit specialni postup
	{
	float obx[4];
	float oby[4];
	float sinR=(float)sin(share->R);
	float cosR=(float)cos(share->R);
	for(int i=0;i<4;i++)
		{//otocime obrys podle auta a posuneme podle polohy auta vuci budove
		obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR;
		oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR;
		obx[i]+=share->X-mx-stat->X;
		oby[i]+=share->Y-my-stat->Y;
		}
	sinR=(float)sin(-stat->R);
	cosR=(float)cos(-stat->R);//ted otocime vuci budove
	float obxi;
	for(i=0;i<4;i++)
		{//otocime obrys podle auta a posuneme podle polohy auta vuci budove
		obxi=obx[i];
		obx[i]=obx[i]*cosR-oby[i]*sinR;
		oby[i]=oby[i]*cosR+obxi*sinR;
		}
	//ted mame vsechny vrcholy obrysu auta relativne vuci neotocenemu obrysu budovy
	if(SUCCEEDED(((TBudova *)pom)->Kolize(obx,oby)))
		{
		if(pom->pojede[2])//znamena zda jeep projede touto prekazkou ci ne
			return S_OK;//projedu
		return E_ACCESSDENIED;//neprojedu
		}
	}//casem mozna predelat, ze budu volat pouze kolize pro staticke objekty a jako parametr davat vozidlo
else
	{//predelat (obrys jeepu)
	if(pom->range==0.0)
		return E_FAIL;//nekoliduje s nicim	
	float gx=mx+stat->X-share->X;
	float gy=my+stat->Y-share->Y;//poloha vuci jeepu
	float ngx;
	float ngy;//nova gx a gy otocena podle auta
	float sinR=(float)sin(-share->R);
	float cosR=(float)cos(-share->R);
	ngx=gx*cosR-gy*sinR;
	ngy=gy*cosR+gx*sinR;
	//ted mame v ngx a ngy sour stat. relativne vuci obrysu auta
	for(int i=0;i<4;i++)
		{
		if(_hypot(ObrysX[i]-ngx,ObrysY[i]-ngy)<pom->range)
			{
			if(pom->pojede[2])//znamena zda jeep projede touto prekazkou ci ne
				return S_OK;//projedu
			return E_ACCESSDENIED;//neprojedu
			}
		}//vrcholy nezasahuji -> pocitej dal
	for(i=0;i<4;i++)
		{//pres vsechny hrany
		gx=-ObrysX[i]+ObrysX[(i+1)%4];
		gy=-ObrysY[i]+ObrysY[(i+1)%4];
		float t=(gx*(ObrysX[i]-ngx)-gy*(ObrysY[i]-ngy))/(gy*gy-gx*gx);
		if(t>0&&t<1)
			{//teoreticky muze zasahovat do hrany aniz zasahuje do vrcholu
			if(_hypot(ObrysX[i]+t*gx-ngx,ObrysY[i]+t*gy-ngy)<pom->range)
				{
				if(pom->pojede[2])//znamena zda jeep projede touto prekazkou ci ne
					return S_OK;//projedu
				return E_ACCESSDENIED;//neprojedu
				}
			}
		}
	}
return E_FAIL;
}

HRESULT TArmo::Kolize(TCar *car)
{//zjisti zda koliduji s jinym autem
if(car->Typ==3)
	return E_FAIL;//s vrtulnikem se proste nesrazim
float obx[4];
float oby[4];
float obx2[4];
float oby2[4];
float sinR=(float)sin(share->R);
float cosR=(float)cos(share->R);
for(int i=0;i<4;i++)
	{//vypocteme absolutni souradnice obrysu tohoto auta
	obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR+share->X;
	oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR+share->Y;
	}
sinR=(float)sin(car->share->R);
cosR=(float)cos(car->share->R);
for(i=0;i<4;i++)
	{//vypocteme absolutni souradnice obrysu druheho auta
	obx2[i]=car->ObrysX[i]*cosR-car->ObrysY[i]*sinR+car->share->X;
	oby2[i]=car->ObrysY[i]*cosR+car->ObrysX[i]*sinR+car->share->Y;
	}
if(Prekryv(obx,oby,obx2,oby2))
	return S_OK;//kolize
return E_FAIL;
}

HRESULT THeli::Kolize(TCar *car)
{//zjisti zda koliduji s jinym autem
if(car->Typ!=3)
	return E_FAIL;//s nicim jinym nez s vrtulnikem se proste nesrazim
float obx[4];
float oby[4];
float obx2[4];
float oby2[4];
float sinR=(float)sin(share->R);
float cosR=(float)cos(share->R);
for(int i=0;i<4;i++)
	{//vypocteme absolutni souradnice obrysu tohoto auta
	obx[i]=ObrysX[i]*cosR-ObrysY[i]*sinR+share->X;
	oby[i]=ObrysY[i]*cosR+ObrysX[i]*sinR+share->Y;
	}
sinR=(float)sin(car->share->R);
cosR=(float)cos(car->share->R);
for(i=0;i<4;i++)
	{//vypocteme absolutni souradnice obrysu druheho auta
	obx2[i]=car->ObrysX[i]*cosR-car->ObrysY[i]*sinR+car->share->X;
	oby2[i]=car->ObrysY[i]*cosR+car->ObrysX[i]*sinR+car->share->Y;
	}
if(Prekryv(obx,oby,obx2,oby2))
	return S_OK;//kolize
return E_FAIL;
}

void TCar::CompDeSync()
{
if(share->NextSyncTime>0)
	{
	float koef=((float)(share->NextSyncTime)/((float)SYNC_INTERVAL));
	deX=share->X+share->deSyncX*koef;
	deY=share->Y+share->deSyncY*koef;
	deR=share->R+share->deSyncR*koef;
	}
else
	{
	deX=share->X;
	deY=share->Y;
	deR=share->R;
	}
}


HRESULT TCar::Move(DWORD actkeys,float time)
{
float maxrych=this->maxrych;
float invmaxrych=this->invmaxrych;

if(SUCCEEDED(VeVode(share->X,share->Y)))
	{
	maxrych/=2.0f;
	invmaxrych/=2.0f;
	}

if(share->Typ==0)
	share->Fuel-=time*JEEP_KLIDSPOTREBA;
else
	share->Fuel-=time*ARMO_KLIDSPOTREBA;

share->RVrt1+=time*5.0f;//houpani na vode

if((actkeys&KEY_LEFT)&&(actkeys&KEY_RIGHT))
	{//vyrusi se
    actkeys &= ~KEY_LEFT;
    actkeys &= ~KEY_RIGHT;
	}
if(((actkeys&KEY_FRONT)&&(actkeys&KEY_BACK))||share->Fuel<=0)//palivo kontrola
	{//vyrusi se
    actkeys &= ~KEY_FRONT;
    actkeys &= ~KEY_BACK;
	}
/****zmena rotace a rychlosti****/
if(actkeys&KEY_LEFT)
	{//jedu doleva
	share->R-=share->rych*maxrotrych*time;
	}
else if(actkeys&KEY_RIGHT)
	{//jedu doprava
	share->R+=share->rych*maxrotrych*time;
	}
if(actkeys&KEY_FRONT)
	{
	if(share->rych<0)//brzdim
		{
		share->rych+=decc*time;
		if(share->rych>0)
			share->rych=0;
		}
	else 
		{//rozjizdim se
		share->rych+=acc*time;
		if(share->rych>maxrych)
			share->rych=maxrych;
		}
	}
else if(actkeys&KEY_BACK)
	{
	if(share->rych>0)
		{//brzdim
		share->rych-=decc*time;
		if(share->rych<0)
			share->rych=0;
		}
	else
		{//rozjizdim se zpateckou
		share->rych-=invacc*time;
		if(share->rych<-invmaxrych)
			share->rych=-invmaxrych;
		}
	}
else
	{//neni zmackly ani plyn ani brzda >> samovolne zastaveni
	if(share->rych>0)
		{
		share->rych-=odpor*time;
		if(share->rych<0)
			share->rych=0;
		}
	else if(share->rych<0)
		{
		share->rych+=odpor*time;
		if(share->rych>0)
			share->rych=0;
		}
	}
/*****zmena polohy***********/
if(share->R>g_2_PI)share->R-=g_2_PI;
else if(share->R<0)share->R+=g_2_PI;//korekce uhlu
float dx=(float)cos(share->R)*share->rych*time;
float dy=(float)sin(share->R)*share->rych*time;
share->X+=dx;
share->Y+=dy;

if(share->rych!=0)
	{//spotreba vzrusta
	if(share->Typ==0)
		share->Fuel-=time*JEEP_SPOTREBA;
	else
		share->Fuel-=time*ARMO_SPOTREBA;
	}
if(share->Fuel<0)
	share->Fuel=0;

if(SUCCEEDED(VeVode(share->X,share->Y)))//voda
	share->cilZ=-0.1f;
else	
	share->cilZ=0;
share->Z+=(share->cilZ-share->Z)*(float)_hypot(dx,dy)*10.0f;

if(share->RVrt1>g_2_PI)share->RVrt1-=g_2_PI;
else if(share->RVrt1<0)share->RVrt1+=g_2_PI;//korekce uhlu houpani

return S_OK;
}

HRESULT TTank::Move(DWORD actkeys,float time)
{
share->Fuel-=time*TANK_KLIDSPOTREBA;

if(((actkeys&KEY_LEFT)&&(actkeys&KEY_RIGHT))||share->Fuel<=0)//palivo kontrola
	{//vyrusi se
    actkeys &= ~KEY_LEFT;
    actkeys &= ~KEY_RIGHT;
	}
if(((actkeys&KEY_FRONT)&&(actkeys&KEY_BACK))||share->Fuel<=0)//palivo kontrola
	{//vyrusi se
    actkeys &= ~KEY_FRONT;
    actkeys &= ~KEY_BACK;
	}
if((actkeys&KEY_SPLEFT)&&(actkeys&KEY_SPRIGHT))
	{//vyrusi se
    actkeys &= ~KEY_SPLEFT;
    actkeys &= ~KEY_SPRIGHT;
	}
/****zmena rotace a rychlosti****/
if(actkeys&KEY_SPLEFT)
	{//jedu doleva hlavni
	share->RHlav-=maxrotrych*time;
	}
else if(actkeys&KEY_SPRIGHT)
	{//jedu doprava hlavni
	share->RHlav+=maxrotrych*time;//toci se i na miste
	}
if(actkeys&KEY_LEFT)
	{//jedu doleva
	share->R-=maxrotrych*time;
	}
else if(actkeys&KEY_RIGHT)
	{//jedu doprava
	share->R+=maxrotrych*time;//toci se i na miste
	}
if(actkeys&KEY_FRONT)
	{
	if(share->rych<0)//brzdim
		{
		share->rych+=decc*time;
		if(share->rych>0)
			share->rych=0;
		}
	else 
		{//rozjizdim se
		share->rych+=acc*time;
		if(share->rych>maxrych)
			share->rych=maxrych;
		}
	}
else if(actkeys&KEY_BACK)
	{
	if(share->rych>0)
		{//brzdim
		share->rych-=decc*time;
		if(share->rych<0)
			share->rych=0;
		}
	else 
		{//rozjizdim se zpateckou
		share->rych-=invacc*time;
		if(share->rych<-invmaxrych)
			share->rych=-invmaxrych;
		}
	}
else
	{//neni zmackly ani plyn ani brzda >> samovolne zastaveni
	if(share->rych>0)
		{
		share->rych-=odpor*time;
		if(share->rych<0)
			share->rych=0;
		}
	else if(share->rych<0)
		{
		share->rych+=odpor*time;
		if(share->rych>0)
			share->rych=0;
		}
	}
/*****zmena polohy***********/
if(share->R>g_2_PI)share->R-=g_2_PI;
else if(share->R<0)share->R+=g_2_PI;//korekce uhlu
if(share->RHlav>g_2_PI)share->RHlav-=g_2_PI;
else if(share->RHlav<0)share->RHlav+=g_2_PI;//korekce uhlu hlavne
share->X+=(float)cos(share->R)*share->rych*time;
share->Y+=(float)sin(share->R)*share->rych*time;

if(share->rych!=0)
	{//spotreba vzrusta
	share->Fuel-=time*TANK_SPOTREBA;
	}
if(share->Fuel<0)
	share->Fuel=0;

return S_OK;
}

HRESULT THeli::Move(DWORD actkeys,float time)
{
share->RVrt1+=time*5.0f;
share->RVrt2-=time*4.9f;

share->Fuel-=time*HELI_KLIDSPOTREBA;

if((actkeys&KEY_LEFT)&&(actkeys&KEY_RIGHT))
	{//vyrusi se
    actkeys &= ~KEY_LEFT;
    actkeys &= ~KEY_RIGHT;
	}
if((actkeys&KEY_FRONT)&&(actkeys&KEY_BACK))
	{//vyrusi se
    actkeys &= ~KEY_FRONT;
    actkeys &= ~KEY_BACK;
	}
if((actkeys&KEY_SPLEFT)&&(actkeys&KEY_SPRIGHT))
	{//vyrusi se
    actkeys &= ~KEY_SPLEFT;
    actkeys &= ~KEY_SPRIGHT;
	}
/****zmena rotace a rychlosti****/
if(actkeys&KEY_LEFT)
	{//jedu doleva
	share->R-=maxrotrych*time;
	}
else if(actkeys&KEY_RIGHT)
	{//jedu doprava
	share->R+=maxrotrych*time;
	}
/*******dostran*************/
if(actkeys&KEY_SPLEFT)//spleft odpovida normrychlosti kladne
	{
	if(share->normrych<0)//brzdim
		{
		share->normrych+=decc*time;//decc a acc je asi stejne ale pro kompatibilitu
		}
	else
		{//rozjizdim se
		share->normrych+=acc*time;
		}
	if(share->normrych>maxnormrych)
		share->normrych=maxnormrych;
	}
else if(actkeys&KEY_SPRIGHT)
	{
	if(share->normrych>0)//brzdim
		{
		share->normrych-=decc*time;//decc a acc je asi stejne ale pro kompatibilitu
		}
	else
		{//rozjizdim se
		share->normrych-=acc*time;
		}
	if(share->normrych<-maxnormrych)
		share->normrych=-maxnormrych;
	}
else
	{//neni zmackly ani spleft ani spright >> samovolne zastaveni do stran
	if(share->normrych>0)
		{
		share->normrych-=odpor*time;
		if(share->normrych<0)
			share->normrych=0;
		}
	else if(share->normrych<0)
		{
		share->normrych+=odpor*time;
		if(share->normrych>0)
			share->normrych=0;
		}
	}
/******dopredu dozadu**********/
if(actkeys&KEY_FRONT)
	{
	if(share->rych<0)//brzdim
		{
		share->rych+=decc*time;
		if(share->rych>0)
			share->rych=0;
		}
	else
		{//rozjizdim se
		share->rych+=acc*time;
		if(share->rych>maxrych)
			share->rych=maxrych;
		}
	}
else if(actkeys&KEY_BACK)
	{
	if(share->rych>0)
		{//brzdim
		share->rych-=decc*time;
		if(share->rych<0)
			share->rych=0;
		}
	else
		{//rozjizdim se zpateckou
		share->rych-=invacc*time;
		if(share->rych<-invmaxrych)
			share->rych=-invmaxrych;
		}
	}
else
	{//neni zmackly ani plyn ani brzda >> samovolne zastaveni
	if(share->rych>0)
		{
		share->rych-=odpor*time;
		if(share->rych<0)
			share->rych=0;
		}
	else if(share->rych<0)
		{
		share->rych+=odpor*time;
		if(share->rych>0)
			share->rych=0;
		}
	}
/*****zmena polohy***********/
if(share->R>g_2_PI)share->R-=g_2_PI;
else if(share->R<0)share->R+=g_2_PI;//korekce uhlu
if(share->RVrt1>g_2_PI)share->RVrt1-=g_2_PI;
else if(share->RVrt1<0)share->RVrt1+=g_2_PI;//korekce uhlu vrtule
if(share->RVrt2>g_2_PI)share->RVrt2-=g_2_PI;
else if(share->RVrt2<0)share->RVrt2+=g_2_PI;//korekce uhlu vrtule
share->X+=(float)cos(share->R)*share->rych*time+(float)sin(share->R)*share->normrych*time;
share->Y+=(float)sin(share->R)*share->rych*time-(float)cos(share->R)*share->normrych*time;

if(share->rych!=0||share->normrych!=0)
	{//spotreba vzrusta
	share->Fuel-=time*HELI_SPOTREBA;
	}
if(share->Fuel<0)
	share->Fuel=0;

return S_OK;
}


/***********KAMERA********************/

/*   1. pohyb podle aktualniho auta    */
HRESULT MoveCameraByCar(float time,BOOL reset)//v sekundach!!
{
SHIP  ship;
DWORD dwSize = sizeof(ship);
HRESULT hr;
hr = DPlayGetPlayerData(gOurID, &ship, &dwSize, DPGET_LOCAL);
if (FAILED(hr))
    {
    TRACE(TEXT("Get Player local data failed for id %d\n"), gOurID);
	return E_FAIL;
	}
/**********************zpusob pohybu kamery predelat, aby nemohla ostrit do nekonecna**********************/
vLookatPt.y=0.0f;
vLookatPt.x=ship.X;
vLookatPt.z=-ship.Y;

//odkud koukam
if(EngUmiram)
	{//final2
	EngCam.cilX=ship.X+UMIRANI_LEN*(float)cos(gBasekaTime*UMIRANI_KOEF);
	EngCam.cilY=ship.Y+UMIRANI_LEN*(float)sin(gBasekaTime*UMIRANI_KOEF);
	EngCam.cilZ=UMIRANI_LEN;
	}
else
if(EngCumShora)
	{
	EngCam.cilX=ship.X;
	EngCam.cilY=ship.Y+4.0f;
	EngCam.cilZ=7.0f;
	}
else
	{
	EngCam.cilX=ship.X;
	EngCam.cilY=ship.Y+2.0f+0.5f*(float)fabs(ship.rych);//5.0puvodne//koresponduje s computegame (menit soucasne)
	EngCam.cilZ=3.5f+0.5f*(float)fabs(ship.rych);//5.0 puvodne!!!
	}
/****korekce rychlosti kamry (kdyz je hdne daleko, tak se pohybuje mnohem rychleji)*********/
float len=(float)_hypot(vEyePt.x-ship.X,vEyePt.z+ship.Y);
if(len>3.5f)
	{
	EngCam.maxrych+=time*0.3f;
	if(EngCam.maxrych>2.3f)//ne vsak rychleji nez 2.3f
		EngCam.maxrych=2.3f;
	}
else
	{
	EngCam.maxrych-=time*0.3f;
	if(EngCam.maxrych<1.0f)
		EngCam.maxrych=1.0f;
	}
len=(float)_hypot(_hypot(vEyePt.x-EngCam.cilX,vEyePt.y-EngCam.cilZ),vEyePt.z+EngCam.cilY);
if(len<=EngCam.maxrych*time||reset)
	{//dosahl jsem cile
	vEyePt.x=EngCam.cilX;
	vEyePt.y=EngCam.cilZ;
	vEyePt.z=-EngCam.cilY;
	}
else
	{//jeste se posunuju
	vEyePt.x-=time*EngCam.maxrych*((vEyePt.x-EngCam.cilX)/len);
	vEyePt.y-=time*EngCam.maxrych*((vEyePt.y-EngCam.cilZ)/len);
	vEyePt.z-=time*EngCam.maxrych*((vEyePt.z+EngCam.cilY)/len);
	}
return S_OK;
}


/*******BUDOVY*************/

HRESULT TBudova::Display(LPDIRECT3DDEVICE3 pd3dDevice,float x,float y,float r,DWORD time)//zobrazi budovu na x,y a otocenou o r (cas pro animaci)
{
D3DMATRIX matRotat;
D3DMATRIX matTrans;
D3DUtil_SetRotateYMatrix(matRotat,r);
D3DUtil_SetTranslateMatrix(matTrans,x,0,-y);
D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);
return Objekt3D->Render(pd3dDevice,g_pmtrlObjectMtrl);
}

HRESULT TBudova::Load(char *filename)
{
if(!Objekt3D)
	return E_FAIL;
return Objekt3D->Load(filename);
}

/*HRESULT TBudova::Kolize(float x,float y,float R)//zda bod (relativni souradnice) nekoliduje z budovou dle obrysu
//navic musi byt bod prepocitan do souradnic modelu budovy (tedy s otoceni 0stupnu)
{
TFloatRect *rect;
Obrys.Reset();
while(rect=Obrys.Next())
	{//top ma mensi y nez bottom
	if(rect->left<x&&rect->right>x&&rect->top<y&&rect->bottom>y)
		return S_OK;//kolize nastala
	}
return E_FAIL;//kolize nenastala
}*/

HRESULT TBudova::Kolize(float *x,float *y)//zda ctyruhelnik (relativni souradnice) nekoliduje s budovou dle obrysu
{
TFloatRect *rect;
float bx[4];
float by[4];
Obrys.Reset();
while(rect=Obrys.Next())
	{//top ma mensi y nez bottom
	bx[0]=rect->left;
	bx[1]=rect->left;
	bx[2]=rect->right;
	bx[3]=rect->right;
	by[0]=rect->top;
	by[1]=rect->bottom;
	by[2]=rect->bottom;
	by[3]=rect->top;
	if(Prekryv(x,y,bx,by))
		return S_OK;//kolize nastala
	}
return E_FAIL;//kolize nenastala
}

/*HRESULT TBudova::Kolize(TCar *car,float R)//zda bod (relativni souradnice) nekoliduje z budovou dle obrysu
//navic musi byt bod prepocitan do souradnic modelu budovy (tedy s otoceni 0stupnu)
{//total dodelat
return E_FAIL;//kolize nenastala
}*///nove zruseno


HRESULT TStrela::Display(LPDIRECT3DDEVICE3 pd3dDevice,DWORD time)//zobrazi strelu
{
D3DMATRIX matRotat;
D3DMATRIX matTrans;

float vzd=(float)hypot(dX,dY);
float r=(float)acos(dX/vzd);//vypocte uhel ze slozek rychlosti
if(dY<0)r=2*3.1415926535f-r;

if(Typ==2)
	{//granat
	D3DUtil_SetRotateYMatrix(matRotat,r+Dolet*5.0f);
	D3DUtil_SetTranslateMatrix(matTrans,X,(float)fabs(sin(g_PI*Dolet/2.0f))*0.5f,-Y);//dodelat aby strely vyletavaly z hlavni atd.
	D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
	pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);
	return StrelaModely[Typ].Render(pd3dDevice,g_pmtrlObjectMtrl);
	}
else
if(Typ==0)
	{//delo
	D3DUtil_SetRotateYMatrix(matRotat,r);
	if(From==1)
		{//vystreleno z tanku
		if(Vyska==0)
			{
			if(Dolet>4.0f)
				D3DUtil_SetTranslateMatrix(matTrans,X,0.45f*(Dolet-4.0f)+0.25f*(5.0f-Dolet),-Y);//dodelat aby strely vyletavaly z hlavni atd.
			else
				D3DUtil_SetTranslateMatrix(matTrans,X,0.25f,-Y);//dodelat aby strely vyletavaly z hlavni atd.
			}
		else
			{
			if(Dolet>4.0f)
				D3DUtil_SetTranslateMatrix(matTrans,X,0.45f*(Dolet-4.0f)+HELI_VYS*(5.0f-Dolet),-Y);//dodelat aby strely vyletavaly z hlavni atd.
			else
				D3DUtil_SetTranslateMatrix(matTrans,X,HELI_VYS,-Y);//dodelat aby strely vyletavaly z hlavni atd.
			}
		}
	else
		{//vystreleno z heli
		if(Vyska==0)
			{
			if(Dolet>4.0f)
				D3DUtil_SetTranslateMatrix(matTrans,X,HELI_VYS*(Dolet-4.0f)+0.25f*(5.0f-Dolet),-Y);//dodelat aby strely vyletavaly z hlavni atd.
			else
				D3DUtil_SetTranslateMatrix(matTrans,X,0.25f,-Y);//dodelat aby strely vyletavaly z hlavni atd.
			}
		else
			{
			D3DUtil_SetTranslateMatrix(matTrans,X,HELI_VYS,-Y);//dodelat aby strely vyletavaly z hlavni atd.
			}
		}
	D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
	pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);
	return StrelaModely[Typ].Render(pd3dDevice,g_pmtrlObjectMtrl);
	}
else
	{//raketa
	D3DUtil_SetRotateYMatrix(matRotat,r);
	if(From==2)
		{//vystreleno z armo
		if(Vyska==0)
			{
			if(Dolet>14.0f)
				D3DUtil_SetTranslateMatrix(matTrans,X,0.45f*(Dolet-14.0f)+0.25f*(15.0f-Dolet),-Y);//dodelat aby strely vyletavaly z hlavni atd.
			else
				D3DUtil_SetTranslateMatrix(matTrans,X,0.25f,-Y);//dodelat aby strely vyletavaly z hlavni atd.
			}
		else
			{
			if(Dolet>14.0f)
				D3DUtil_SetTranslateMatrix(matTrans,X,0.45f*(Dolet-14.0f)+HELI_VYS*(15.0f-Dolet),-Y);//dodelat aby strely vyletavaly z hlavni atd.
			else
				D3DUtil_SetTranslateMatrix(matTrans,X,HELI_VYS,-Y);//dodelat aby strely vyletavaly z hlavni atd.
			}
		}
	else
		{//vystreleno z heli
		if(Vyska==0)
			{
			if(Dolet>14.0f)
				D3DUtil_SetTranslateMatrix(matTrans,X,HELI_VYS*(Dolet-14.0f)+0.25f*(15.0f-Dolet),-Y);//dodelat aby strely vyletavaly z hlavni atd.
			else
				D3DUtil_SetTranslateMatrix(matTrans,X,0.25f,-Y);//dodelat aby strely vyletavaly z hlavni atd.
			}
		else
			{
			D3DUtil_SetTranslateMatrix(matTrans,X,HELI_VYS,-Y);//dodelat aby strely vyletavaly z hlavni atd.
			}
		}
	D3DMath_MatrixMultiply(matTrans,matTrans,matRotat);
	pd3dDevice->SetTransform(D3DTRANSFORMSTATE_WORLD,&matTrans);
	return StrelaModely[Typ].Render(pd3dDevice,g_pmtrlObjectMtrl);
	}
return E_FAIL;
} 

HRESULT TStatic::Hit(TStrela *strela,float x,float y,float r)//musim predat i souradnice x,y, kde se stat nachazi (absolutni)
{
if(strela->Vyska==1)//vzdusna
	return E_FAIL;//nezasahla
if(range==0.0)
	return E_FAIL;//nezasahla
if(_hypot((float)(strela->X-x),(float)(strela->Y-y))<range)
	{
	return S_OK;
	}
return E_FAIL;
}

HRESULT TBudova::Hit(TStrela *strela,float x,float y,float r)//musim predat i souradnice x,y, kde se stat nachazi (absolutni)
{//spec. pretizeni pro budovy
if(strela->Vyska==1)//vzdusna
	return E_FAIL;//nezasahla

float rx,ry;
rx=strela->X-x;
ry=strela->Y-y;//relativne vuci budove

float sinR=(float)sin(-r);//ted jeste otocime podle budovy
float cosR=(float)cos(-r);
float temp=rx;
rx=rx*cosR-ry*sinR;
ry=ry*cosR+temp*sinR;

TFloatRect *rect;
float bx[4];
float by[4];
Obrys.Reset();
while(rect=Obrys.Next())
	{//top ma mensi y nez bottom
	bx[0]=rect->left;
	bx[1]=rect->left;
	bx[2]=rect->right;
	bx[3]=rect->right;
	by[0]=rect->top;
	by[1]=rect->bottom;
	by[2]=rect->bottom;
	by[3]=rect->top;
	if(Uvnitr(bx,by,rx,ry))
		return S_OK;//kolize nastala
	}
return E_FAIL;//kolize nenastala
}

HRESULT TStrela::Move(float time)
{
float dif=(float)_hypot(dX*time,dY*time);
Dolet-=dif;//snizeni zbyvajiciho doletu
X+=dX*time;//posun
Y+=dY*time;
/*if(Dolet<-1e-6f)//uz bych preletel
	{//udelej posun na cil zpet
	X+=((dX*time)/dif)*Dolet;//posun na cil
	Y+=((dY*time)/dif)*Dolet;
	}*/
return S_OK;
}

