#define D3D_OVERLOADS
#include "btkclass.h"
#include "pomocne.h"

#include "utils\d3dtextr.h"
#include "utils\d3dutil.h"
#include "XFiles\xfileloader.h"
#include "pomocne.h"

//directsound
#include "dsutil.h"
#include "dsnd.h"

#include "dplay\comm.h"
#include "dplay\vsichni.h"
#include "dplay\wizard.h"
#include "input.h"
#include "engine.h"
#include "render.h"
#include "main.h"

//externa functions from gamebase.cpp
TCar *MakeCar(LPSHIP lpShip);
TCar *MakeCar2(LPSHIP lpShip);
void SendChangeMess(TStatSpoj *obj,int x,int y,int cim);
//cim:-1..ihned znicit(nebo pridat novy objekt) 0,1,2..pouze upravit damage podle typu strely

void    DestroyShip( LPSHIP lpShip,int flag=0);

BOOL DEMOmapvis=TRUE;

char *NazvyZbrani[4][2]={
{"Granaty","Error - neexistuje"},
{"Delo","Error - neexistuje"},
{"Rakety","Miny"},
{"Rakety","Delo"}
};

char *LoadRadTex[8]={
"radjeep.bmp",
"radtank.bmp",
"radarmo.bmp",
"radheli.bmp",
"nradjeep.bmp",
"nradtank.bmp",
"nradarmo.bmp",
"nradheli.bmp",
};

char *LoadLevPath=".\\Levels";
char *LoadHracModels[7]={
"3dmodely\\jeep.x",
"3dmodely\\tank.x",
"3dmodely\\armo.x",
"3dmodely\\heli.x",
"3dmodely\\hlaven.x",
"3dmodely\\vrtheli1.x",
"3dmodely\\vrtheli2.x"};

char *LoadStrelaModels[3]={
"3dmodely\\basic.x",
"3dmodely\\raketa.x",
"3dmodely\\granat.x"};

char *LoadVlajModels[2]={
"3dmodely\\baba_my.x",
"3dmodely\\baba_oni.x"
};


TSpojak <TText> TextInfo;

float INIT_ANGLE=1.570796f;

float gBitkaTime;
float gBasekaTime;
float basekaX;
float basekaY;//prostredek baseky (pro vraceni se na zakladnu)

int LocState=0;//0.. prohlizim auta, 1.. prohlizim globalni mapku
float GlobX=0;
float GlobY=0;
float GlobZoom=5.0f;//aktualni nastaveni globalni mapky

BOOL EngSamoZnic=false;

int EngCumShora=0;

int EngUmiram=0;

int EngActZbran=0;
BOOL gbRadar=true;

BOOL EngWaitOnCar=false;
BOOL EngHaveACar=false;
int EngDruzstvo=0;//prislusnost k druzstvu
/***userinterface structures****/
TexCont *EngIntMain=NULL;//hlavni textura
TexCont *EngRadarTex=NULL;//hlavni textura
TexCont *EngPodTex=NULL;//podzemnui textura

TexCont *RadTex[8];//hlavni textura



/****Level depend****/
TMapka *EngMapa=NULL;//mapa prostredi
TSpojak <TStrela> *EngSStrely=NULL;//spojak vsech leticich strel
//TSpojak <TAnimSpoj> *EngSAnim=NULL;//spojak odkazu na probihajici animace
//TSpojak <TZmena> *EngDynam=NULL;//nove zruseno
//DWORD EngNearestTime;//nove zruseno

/****moje aktualni auto*****/
//TCar *EngActCar=NULL;
TJeep EngJeep;
TTank EngTank;
TArmo EngArmo;
THeli EngHeli;//sablony pro vypocty multiplayeru pomoci starych rutin

TJeep EngJeep2;
TTank EngTank2;
TArmo EngArmo2;
THeli EngHeli2;//sablony pro vypocty multiplayeru pomoci starych rutin (kolize dvou aut navzajem)

/********zdroje**********/
TZdroje EngZdroj[2];//zdroje pro 1. i 2. stranu
BOOL EngEnd[2]={0,0};

int EngScore[2]={0,0};
int EngPocetHracu[2]={0,0};//pocet hracu za jednotliva druzstva
int EngPocetEnabHracu[2]={0,0};//pocet hracu za jednotliva druzstva

/*****platne po celou dobu programu (init/deinit)********/
//TStatic **EngAnim=NULL;//pole vsech moznych animaci (load textury a pak draw podle casu...zhruba)
//ted prerazeno pod EngStatic

TStatic **EngStatic=NULL;//seznam vsech moznych statickych objektu
CD3DFileObject *AutoModely=NULL;//zde budou ulozeny modely aut (vyuziti ve vice animacich)
//0..3 auta
//4 hlaven tanku
//5,6 vrtule
CD3DFileObject *StrelaModely=NULL;//zde budou ulozeny modely aut (vyuziti ve vice animacich)
CD3DFileObject *VlajModely=NULL;//zde budou ulozeny modely vlajecek 
TexCont **EngMapaTextury=NULL;//pole pointru na textury podkladu mapky

/***************Mapa textury********************/

HRESULT InitMapTextures()
{//onetimeinit
char fname[64];
EngMapaTextury=new TexCont *[LIM_MAPTEXMAX];
if(!EngMapaTextury)
	return E_FAIL;
LoadTexPath=".\\Textur";
for(int i=0;i<LIM_MAPTEXMAX;i++)
	{
	sprintf(fname,"tex%d.bmp",i);
	EngMapaTextury[i]=MyTextr_CreateTexture(fname);
	}
return S_OK;
}

HRESULT DeInitMapTextures()
{//onetimedeinit
if(EngMapaTextury)
for(int i=0;i<LIM_MAPTEXMAX;i++)
	{
	SAFE_DELETE(EngMapaTextury[i]);
	}
SAFE_DELETEARRAY(EngMapaTextury);
return S_OK;
}

HRESULT RestoreMapTextures(LPDIRECT3DDEVICE3 pd3dDevice)
{
HRESULT hr=S_OK;
for(int i=0;i<LIM_MAPTEXMAX;i++)
	{
	if(EngMapaTextury[i])
		{
		if(FAILED(MyTextr_Restore(EngMapaTextury[i],pd3dDevice)))
			hr=E_FAIL;
		}
	}
return hr;
}

HRESULT InvalidateMapTextures()
{
if(EngMapaTextury)
for(int i=0;i<LIM_MAPTEXMAX;i++)
	{
	if(EngMapaTextury[i])
		{
        SAFE_RELEASE( EngMapaTextury[i]->ptexTexture );
        SAFE_RELEASE( EngMapaTextury[i]->pddsSurface );
		}
	}
return S_OK;
}

/***********interface textures***********/

HRESULT InitInterfaceTex()
{//onetimeinit
LoadTexPath=".\\Textur";
if(!(EngIntMain=MyTextr_CreateTexture("Iface1.bmp")))
	return E_FAIL;
if(!(EngRadarTex=MyTextr_CreateTexture("Radar.bmp",0,DDSD_CKSRCBLT)))
	return E_FAIL;
if(!(EngPodTex=MyTextr_CreateTexture("Podzemi.bmp")))
	return E_FAIL;
for(int i=0;i<8;i++)
	{
	if(!(RadTex[i]=MyTextr_CreateTexture(LoadRadTex[i],0,DDSD_CKSRCBLT)))
	return E_FAIL;
	}
return S_OK;
}

HRESULT DeInitInterfaceTex()
{//onetimedeinit
SAFE_DELETE(EngIntMain);
SAFE_DELETE(EngRadarTex);
SAFE_DELETE(EngPodTex);
for(int i=0;i<8;i++)
	{
	SAFE_DELETE(RadTex[i]);
	}
return S_OK;
}

HRESULT RestoreInterfaceTex(LPDIRECT3DDEVICE3 pd3dDevice)
{
if(FAILED(MyTextr_Restore(EngIntMain,pd3dDevice)))
	return E_FAIL;
if(FAILED(MyTextr_Restore(EngRadarTex,pd3dDevice)))
	return E_FAIL;
if(FAILED(MyTextr_Restore(EngPodTex,pd3dDevice)))
	return E_FAIL;
for(int i=0;i<8;i++)
	{
	if(FAILED(MyTextr_Restore(RadTex[i],pd3dDevice)))
		return E_FAIL;
	}
return S_OK;
}

HRESULT InvalidateInterfaceTex()
{
if(EngIntMain)
	{
    SAFE_RELEASE(EngIntMain->ptexTexture);
    SAFE_RELEASE(EngIntMain->pddsSurface);
	}
if(EngRadarTex)
	{
    SAFE_RELEASE(EngRadarTex->ptexTexture);
    SAFE_RELEASE(EngRadarTex->pddsSurface);
	}
if(EngPodTex)
	{
    SAFE_RELEASE(EngPodTex->ptexTexture);
    SAFE_RELEASE(EngPodTex->pddsSurface);
	}
for(int i=0;i<8;i++)
	{
	if(RadTex[i])
		{
		SAFE_RELEASE(RadTex[i]->ptexTexture);
		SAFE_RELEASE(RadTex[i]->pddsSurface);
		}
	}
return S_OK;
}


/***************Init/deinit level************************/
//druha verze s textovou verzi souboru s levely

HRESULT InitLevel(char* strName)//dodelat nakonec ochranu proti zatuhnuti kvuli vadnemu souboru
{//predpoklada ze level v tomto okaziku neni inicializovan!!
//char strFullPath[256];
char Header[64];
int sx,sy;
FILE *in;

EngSStrely=new TSpojak <TStrela>;
if(!EngSStrely)
	return E_OUTOFMEMORY;

//sprintf(strFullPath,"%s\\%s",LoadLevPath,strName);
in=fopen(strName,"rt");
if(!in)
	return MK_E_CANTOPENFILE;


//fread(Header,sizeof(char),HEADERSIZE,in);
fscanf(in,"%32s",Header);
if(feof(in)||strcmp(Header,"MapSize:"))
	{
	fclose(in);
	return STG_E_DOCFILECORRUPT;
	}
fscanf(in,"%i",&sx);
fscanf(in,"%i",&sy);
if(sx<MINSIZEMAP||sx>MAXSIZEMAP||sy<MINSIZEMAP||sy>MAXSIZEMAP||feof(in))//rozmer mapky je mimo meze
	{
	fclose(in);
	return STG_E_DOCFILECORRUPT;
	}
fscanf(in,"%32s",Header);
if(feof(in)||strcmp(Header,"Map:"))
	{
	fclose(in);
	return STG_E_DOCFILECORRUPT;
	}
EngMapa=new TMapka(sx,sy);//pocatecni rozmery
if(!EngMapa||!EngMapa->Mapa)
	{
	fclose(in);
	return E_OUTOFMEMORY;
	}
for(int y=0;y<sy;y++)
for(int x=0;x<sx;x++)
	{//nacti mapku
	int num;
	fscanf(in,"%i",&num);
	EngMapa->Mapa[x+y*sx].Podklad=num;
//	EngMapa->Mapa[x+y*sx].Podklad=fgetc(in);
	}
fscanf(in,"%32s",Header);
if(feof(in)||strcmp(Header,"EndOfMap:"))
	{//mapka musi byt zakoncena EndOfMap:
	fclose(in);
	return STG_E_DOCFILECORRUPT;
	}
//      nacitani stat objektu
int Index;
float X,Y,R;
int mx,my;//sour v mapce
int tc=0;
//int d;
for(;;)
	{
	fscanf(in,"%32s",Header);
	if(!strcmp(Header,"End:"))
		{//konec levelu
		break;
		}
	if(feof(in)||strcmp(Header,"Stat:"))
		{//chybka
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
//	mx=fgetc(in);
//	my=fgetc(in);
	fscanf(in,"%i",&Index);
	fscanf(in,"%i",&mx);
	fscanf(in,"%i",&my);
	if(Index<0||Index>LIM_STAT||mx<0||mx>=sx||my<0||my>=sy){
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
	if(!EngStatic[Index])
		{//odkaz na neexistujici staticky objekt
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
	fscanf(in,"%g",&X);
	fscanf(in,"%g",&Y);
	fscanf(in,"%g",&R);
	if(feof(in)){//mapka musi byt zakoncemna End:
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
	//nacetl jsem tedy jeden stat objekt a ted ho zaradim do mapy
	TStatSpoj *temp=new TStatSpoj;
	temp->Index=Index;
	if(!EngStatic[Index])
		{
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}//neexistujici objekt
	temp->Damage=EngStatic[Index]->InitDam;
	temp->X=X;
	temp->Y=Y;
	temp->R=-R*g_PI/180;//aby to mel uzivatel jednodussi
	temp->gid.time=tc;
	temp->gid.pid=tc;//naplnim jednoznacny identifikator objektu z levelu
	tc++;
	EngMapa->Mapa[mx+my*sx].Spojak->Add(temp);
	}
fclose(in);
EngAppState=2;
gBasekaTime=0;
SetStartGlobPos();
return S_OK;
}

/*HRESULT InitLevel(char* strName)//dodelat nakonec ochranu proti zatuhnuti kvuli vadnemu souboru
{//predpoklada ze level v tomto okaziku neni inicializovan!!
//char strFullPath[256];
char Header[HEADERSIZE];
int sx,sy;
FILE *in;

EngSStrely=new TSpojak <TStrela>;
if(!EngSStrely)
	return E_OUTOFMEMORY;

//sprintf(strFullPath,"%s\\%s",LoadLevPath,strName);
in=fopen(strName,"rb");
if(!in)
	return MK_E_CANTOPENFILE;
fread(Header,sizeof(char),HEADERSIZE,in);
if(feof(in))
	{
	fclose(in);
	return STG_E_DOCFILECORRUPT;
	}
sx=256*Header[0]+Header[1];
sy=256*Header[2]+Header[3];
if(sx<MINSIZEMAP||sx>MAXSIZEMAP||sy<MINSIZEMAP||sy>MAXSIZEMAP)//rozmer mapky je mimo meze
	{
	fclose(in);
	return STG_E_DOCFILECORRUPT;
	}
EngMapa=new TMapka(sx,sy);//pocatecni rozmery
if(!EngMapa||!EngMapa->Mapa)
	{
	fclose(in);
	return E_OUTOFMEMORY;
	}
for(int y=0;y<sy;y++)
for(int x=0;x<sx;x++)
	{//nacti mapku
	EngMapa->Mapa[x+y*sx].Podklad=fgetc(in);
	}
if(feof(in))
	{//mapka musi byt zakoncemna znakem 255!
	fclose(in);
	return STG_E_DOCFILECORRUPT;
	}
if(255!=fgetc(in))
	{//mapka musi byt zakoncemna znakem 255!
	fclose(in);
	return STG_E_DOCFILECORRUPT;
	}
//      nacitani stat objektu
int Index;
float X,Y,R;
int mx,my;//sour v mapce
int tc=0;
int d0,d1;
for(;;)
	{
	Index=fgetc(in);
	if(255==Index){//konec souboru
		break;
		}
	mx=fgetc(in);
	my=fgetc(in);
	if(Index<0||Index>LIM_STAT||mx<0||mx>=sx||my<0||my>=sy){
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
	d1=fgetc(in);
	d0=fgetc(in);
	if(feof(in)){
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
	X=(float)(256*d1+d0)/(float)(256*256);
	d1=fgetc(in);
	d0=fgetc(in);
	if(feof(in)){
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
	Y=(float)(256*d1+d0)/(float)(256*256);
	d1=fgetc(in);
	d0=fgetc(in);
	if(feof(in)){
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
	R=((float)(256*d1+d0)/(float)(256*256))*g_2_PI;
	if(feof(in)){//mapka musi byt zakoncemna znakem 255!
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
	if(255!=fgetc(in))
		{
		fclose(in);
		return STG_E_DOCFILECORRUPT;
		}
	//nacetl jsem tedy jeden stat objekt a ted ho zaradim do mapy
	TStatSpoj *temp=new TStatSpoj;
	temp->Index=Index;
	temp->X=X;
	temp->Y=Y;
	temp->R=R;
	temp->gid.time=tc;
	temp->gid.pid=tc;//naplnim jednoznacny identifikator objektu z levelu
	tc++;
	EngMapa->Mapa[mx+my*sx].Spojak->Add(temp);
	}
fclose(in);
EngAppState=1;

return S_OK;
}*/

HRESULT DeInitLevel()
{
SAFE_DELETE(EngSStrely);
//SAFE_DELETE(EngDynam);//nove zruseno
//SAFE_DELETE(EngSAnim);
SAFE_DELETE(EngMapa);

//SAFE_DELETE(EngActCar);//nove predelano na 'sablony'
EngAppState=0;

return S_OK;
}


/*********************Rendrovani mapy****************/

HRESULT RenderMap(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect,DWORD ftime )
{//predelat
D3DVERTEX Policko[4];
//                  (tohle se upravi. 
//0   1
//2   3
Policko[0]=D3DVERTEX(D3DVECTOR(0,0,0),D3DVECTOR(0,1,0),0,0);
Policko[1]=D3DVERTEX(D3DVECTOR(0,0,0),D3DVECTOR(0,1,0),1,0);
Policko[2]=D3DVERTEX(D3DVECTOR(0,0,0),D3DVECTOR(0,1,0),0,1);
Policko[3]=D3DVERTEX(D3DVECTOR(0,0,0),D3DVECTOR(0,1,0),1,1);

//kvuli zobrazovani carek mezi policky (obtaceni textur dokola!)

pd3dDevice->SetTextureStageState( 0, D3DTSS_ADDRESS, D3DTADDRESS_MIRROR );//nove

/*pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );
pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );*/
pd3dDevice->SetTextureStageState( 0, D3DTSS_MINFILTER, D3DTFN_LINEAR );
pd3dDevice->SetTextureStageState( 0, D3DTSS_MAGFILTER, D3DTFG_LINEAR );
pd3dDevice->SetRenderState( D3DRENDERSTATE_DITHERENABLE, TRUE );
//pd3dDevice->SetRenderState( D3DRENDERSTATE_SPECULARENABLE, TRUE );

/*pd3dDevice->SetTexture( 0, EngIntMain->ptexTexture);
pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE,  FALSE );
pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHABLENDENABLE, FALSE );*/


D3DUtil_SetIdentityMatrix( matWorld );
pd3dDevice->SetTransform( D3DTRANSFORMSTATE_WORLD,&matWorld );

int sx=EngMapa->SizeX;
int sy=EngMapa->SizeY;
for(int y=MapVisibleFromY;y<=MapVisibleToY;y++)
for(int x=MapVisibleFromX;x<=MapVisibleToX;x++)
	{
	Policko[0].x=(float)x;
	Policko[0].z=(float)(-y);
	Policko[1].x=(float)(x+1);
	Policko[1].z=(float)(-y);
	Policko[2].x=(float)x;
	Policko[2].z=(float)(-y-1);
	Policko[3].x=(float)(x+1);
	Policko[3].z=(float)(-y-1);
	if(x>=0&&x<sx&&y>=0&&y<sy)
	    pd3dDevice->SetTexture(0,EngMapaTextury[EngMapa->Mapa[x+y*sx].Podklad]->ptexTexture);
	else
	    pd3dDevice->SetTexture(0,EngMapaTextury[0]->ptexTexture);//textura 0 se pouzije vsude mimo mapku
	if(DEMOmapvis)
		pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,Policko,4,0/*D3DDP_WAIT*/);
	}
TStatSpoj *obj;
int pruchod=0;
do{
	pruchod++;//predelano na dvoupruchodove renderovani
	if(pruchod==1)//aby to nedelalo z-buf neplechu
		pd3dDevice->SetRenderState(D3DRENDERSTATE_ZFUNC,D3DCMP_ALWAYS);//pokus
	else
		pd3dDevice->SetRenderState( D3DRENDERSTATE_ZFUNC,D3DCMP_LESSEQUAL);//pokus
	for(y=MapVisibleFromY;y<=MapVisibleToY;y++)
	for(int x=MapVisibleFromX;x<=MapVisibleToX;x++)
		{
		if(!(x>=0&&x<sx&&y>=0&&y<sy))
			continue;//pokud nejsem v mapce tak preskocit
		//a ted to vykresli ty staticke objekty
		EngMapa->Mapa[x+y*sx].Spojak->Reset();
		while(obj=EngMapa->Mapa[x+y*sx].Spojak->Next())
			{
			if(EngStatic[obj->Index])
				{
	/*			if(EngStatic[obj->Index]->typ<0)//nove zruseno
					{//je to animace
					DWORD atm=EngStatic[obj->Index]->animtime-(ftime-obj->time);
					if(atm<=0)
						{
						EngMapa->Mapa[x+y*sx].Spojak->Delete();
						}
					else//jinak jeste animuj
						EngStatic[obj->Index]->Display(pd3dDevice,(float)x+obj->X,(float)y+obj->Y,obj->R,atm);
					}
				else*/
				if(pruchod==1&&EngStatic[obj->Index]->typ==TYP_TSTATIC)
					EngStatic[obj->Index]->Display(pd3dDevice,(float)x+obj->X,(float)y+obj->Y,obj->R,0);
				else if(pruchod==2&&EngStatic[obj->Index]->typ!=TYP_TSTATIC)
					EngStatic[obj->Index]->Display(pd3dDevice,(float)x+obj->X,(float)y+obj->Y,obj->R,0);
				}
			}
		}
	}while(pruchod!=2);
//vykresleni strel
TStrela *strela;
EngSStrely->Reset();
while(strela=EngSStrely->Next())
	{//projdu vsechny letici strely
	if((int)(strela->X)>=MapVisibleFromX&&(int)(strela->X)<=MapVisibleToX&&(int)(strela->Y)>=MapVisibleFromY&&(int)(strela->Y)<=MapVisibleToY)
		{//je asi viditelna
		strela->Display(pd3dDevice,ftime);//zobraz ji
		}
	}
return S_OK;
}


/*********init deinit game object****************************/

HRESULT RestoreStatic(LPDIRECT3DDEVICE3 pd3dDevice )
{
for(int i=0;i<LIM_STAT;i++)
	if(EngStatic[i])
		{
		EngStatic[i]->Restore(pd3dDevice);
		}
return S_OK;
}

HRESULT InvalidateStatic()
{
for(int i=0;i<LIM_STAT;i++)
	if(EngStatic[i])
		{
		EngStatic[i]->Invalidate();
		}
return S_OK;
}

HRESULT RenderRadar(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect,DWORD ftime )
{// !!!musi byt naplneny promene playerbuf atd.
/*
SHIP PlayerBuf[MAX_PLAYERS];
DPID PlayerPID[MAX_PLAYERS];
int PlayerCount;
*/
if(!gbRadar)
	return S_OK;//je vypnuty

float x,y;//kde jsem ja
for(int i=0;i<PlayerCount;i++)
	{
	if(gOurID==PlayerPID[i])
		{
		x=PlayerBuf[i].X;
		y=PlayerBuf[i].Y;
		if(PlayerBuf[i].Typ==0)
			{//je to gazik a ten nema radar!
			return S_OK;
			}
		}
	}
D3DTLVERTEX PozadiMesh[4];

D3DVIEWPORT2 vp;
vp.dwSize = sizeof(vp);
pvViewport->GetViewport2(&vp);
PozadiMesh[0] = D3DTLVERTEX( D3DVECTOR(0,0,0), 0.5f, -1, 0, 0, 1 );
PozadiMesh[1] = D3DTLVERTEX( D3DVECTOR(0,0,0), 0.5f, -1, 0, 0, 0 );
PozadiMesh[2] = D3DTLVERTEX( D3DVECTOR(0,0,0), 0.5f, -1, 0, 1, 1 );
PozadiMesh[3] = D3DTLVERTEX( D3DVECTOR(0,0,0), 0.5f, -1, 0, 1, 0 );

//neco z toho neni treba (mam transformed and lit vertices!!
pd3dDevice->SetTexture( 0, EngIntMain->ptexTexture);
pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE,  FALSE );
pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHABLENDENABLE, FALSE );
pd3dDevice->SetTextureStageState( 0, D3DTSS_MINFILTER, D3DTFN_LINEAR );
pd3dDevice->SetTextureStageState( 0, D3DTSS_MAGFILTER, D3DTFG_LINEAR );
pd3dDevice->SetRenderState( D3DRENDERSTATE_DITHERENABLE, TRUE );

pd3dDevice->SetTextureStageState( 0, D3DTSS_ADDRESS, D3DTADDRESS_MIRROR );//nove

D3DUtil_SetIdentityMatrix( matWorld );
pd3dDevice->SetTransform( D3DTRANSFORMSTATE_WORLD,&matWorld );

float centerx=(FLOAT)vp.dwWidth*7.0f/8.0f;
float centery=(FLOAT)vp.dwHeight-(FLOAT)vp.dwWidth/8.0f;
float koef=(FLOAT)vp.dwWidth/8.0f;
//float mark=(FLOAT)vp.dwWidth/16.0f;
float mark=32.0f;
float x1,x2,y1,y2;
float rx,ry;

pd3dDevice->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE,TRUE);

for(i=0;i<PlayerCount;i++)
	{
	if((float)_hypot(rx=(-x+PlayerBuf[i].X),ry=(-y+PlayerBuf[i].Y))<RADAR_RANGE&&PlayerBuf[i].bEnable)
		{//jeste je videt
	    pd3dDevice->SetTexture(0,RadTex[PlayerBuf[i].Typ+((EngDruzstvo==PlayerBuf[i].byType) ? 0 : 4 )]->ptexTexture);

		x1=centerx+koef*rx/RADAR_RANGE-mark;
		x2=x1+2.0f*mark;
		y1=centery+koef*ry/RADAR_RANGE-mark;
		y2=y1+2.0f*mark;
		PozadiMesh[0].sx = x1;
		PozadiMesh[0].sy = y2;
		PozadiMesh[1].sx = x1;
		PozadiMesh[1].sy = y1;
		PozadiMesh[2].sx = x2;
		PozadiMesh[2].sy = y2;
		PozadiMesh[3].sx = x2;
		PozadiMesh[3].sy = y1;

		pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_TLVERTEX,PozadiMesh,4,0/*D3DDP_WAIT*/);
//		pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,Policko,4,0/*D3DDP_WAIT*/);
		}
	}
PozadiMesh[0].sx = (FLOAT)vp.dwWidth*3.0f/4.0f;
PozadiMesh[0].sy = (FLOAT)vp.dwHeight;
PozadiMesh[1].sx = (FLOAT)vp.dwWidth*3.0f/4.0f;
PozadiMesh[1].sy = (FLOAT)vp.dwHeight-(FLOAT)vp.dwWidth/4.0f;
PozadiMesh[2].sx = (FLOAT)vp.dwWidth;
PozadiMesh[2].sy = (FLOAT)vp.dwHeight;
PozadiMesh[3].sx = (FLOAT)vp.dwWidth;
PozadiMesh[3].sy = (FLOAT)vp.dwHeight-(FLOAT)vp.dwWidth/4.0f;

pd3dDevice->SetTexture(0,EngRadarTex->ptexTexture);
pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_TLVERTEX,PozadiMesh,4,0/*D3DDP_WAIT*/);
pd3dDevice->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE,FALSE);
return S_OK;
}


/*HRESULT RestoreAnim(LPDIRECT3DDEVICE3 pd3dDevice )
{
return S_OK;
}

HRESULT InvalidateAnim()
{
return S_OK;
}*///animace ted jako specialni TStatic

HRESULT InitStatic()
{
TFloatRect *rect;
EngStatic=new TStatic *[LIM_STAT];
if(!EngStatic)
	return E_FAIL;
for(int i=0;i<LIM_STAT;i++)
	EngStatic[i]=NULL;
//tady je naplneni statickych objektu
//vlastnosti stat objektu se specifikuji primo v zde kodu
LoadTexPath=".\\Textur";
//OBJ 0
EngStatic[0]=new TXStatic();
if(FAILED(((TXStatic *)EngStatic[0])->Load("3dmodely\\strom.x")))
	return E_FAIL;
EngStatic[0]->typ=TYP_XSTATIC;
EngStatic[0]->range=0.1f;//vadi jen kmen
EngStatic[0]->pojede[0]=FALSE;//neprojede jen jeep
EngStatic[0]->pojede[1]=TRUE;
EngStatic[0]->pojede[2]=TRUE;
EngStatic[0]->InitDam=0;
//OBJ 1 zatim jen pokusne
EngStatic[1]=new TTStatic();
if(FAILED(((TTStatic *)EngStatic[1])->Load("pstrom.bmp",DDSD_CKSRCBLT)))
	return E_FAIL;
EngStatic[1]->typ=TYP_TSTATIC;
EngStatic[1]->range=0.0;//neni potreba
EngStatic[1]->pojede[0]=TRUE;//projedou vsichni
EngStatic[1]->pojede[1]=TRUE;
EngStatic[1]->pojede[2]=TRUE;
((TTStatic *)EngStatic[1])->ScaleX=0.4f;
((TTStatic *)EngStatic[1])->ScaleY=0.4f;
//OBJ 2//budova
EngStatic[2]=new TBudova();
if(FAILED(((TBudova *)EngStatic[2])->Load("3dmodely\\chal.x")))
	return E_FAIL;
EngStatic[2]->typ=TYP_BUDOVA;
EngStatic[2]->pojede[0]=FALSE;
EngStatic[2]->pojede[1]=FALSE;
EngStatic[2]->pojede[2]=FALSE;
EngStatic[2]->InitDam=1;
rect =new TFloatRect;
rect->left=-0.259f;
rect->right=0.247f;
rect->top=-0.259f;
rect->bottom=0.241f;
((TBudova *)EngStatic[2])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 3 zatim jen pokusne
EngStatic[3]=new TTStatic();
if(FAILED(((TTStatic *)EngStatic[3])->Load("pchal.bmp",DDSD_CKSRCBLT)))
	return E_FAIL;
EngStatic[3]->typ=TYP_TSTATIC;
EngStatic[3]->range=0.0;//neni potreba
EngStatic[3]->pojede[0]=TRUE;//projedou vsichni
EngStatic[3]->pojede[1]=TRUE;
EngStatic[3]->pojede[2]=TRUE;
((TTStatic *)EngStatic[3])->ScaleX=0.4f;
((TTStatic *)EngStatic[3])->ScaleY=0.4f;
//OBJ 4//budova
EngStatic[4]=new TBudova();
if(FAILED(((TBudova *)EngStatic[4])->Load("3dmodely\\barak.x")))
	return E_FAIL;
EngStatic[4]->typ=TYP_BUDOVA;
EngStatic[4]->pojede[0]=FALSE;
EngStatic[4]->pojede[1]=FALSE;
EngStatic[4]->pojede[2]=FALSE;
EngStatic[4]->InitDam=10;
rect =new TFloatRect;
rect->left=-0.5f;
rect->right=0.5f;
rect->top=-0.5f;
rect->bottom=0.5f;
/*rect->left=-0.1f;
rect->right=0.1f;
rect->top=-0.5f;
rect->bottom=0.5f;*/
((TBudova *)EngStatic[4])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 5//budova
EngStatic[5]=new TBudova();
EngStatic[5]->pojede[0]=FALSE;
EngStatic[5]->pojede[1]=FALSE;
EngStatic[5]->pojede[2]=FALSE;
EngStatic[5]->InitDam=10;
if(FAILED(((TBudova *)EngStatic[5])->Load("3dmodely\\bbarak.x")))
	return E_FAIL;
EngStatic[5]->typ=TYP_BUDOVA;
rect =new TFloatRect;
rect->left=-0.5f;
rect->right=0.5f;
rect->top=-0.5f;
rect->bottom=0.5f;
((TBudova *)EngStatic[5])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 6 zatim jen pokusne
EngStatic[6]=new TTStatic();
if(FAILED(((TTStatic *)EngStatic[6])->Load("pbarak.bmp",DDSD_CKSRCBLT)))
	return E_FAIL;
EngStatic[6]->typ=TYP_TSTATIC;
EngStatic[6]->range=0.0;//neni potreba
EngStatic[6]->pojede[0]=TRUE;//projedou vsichni
EngStatic[6]->pojede[1]=TRUE;
EngStatic[6]->pojede[2]=TRUE;
((TTStatic *)EngStatic[6])->ScaleX=0.5f;
((TTStatic *)EngStatic[6])->ScaleY=0.5f;
/**********************///nove
//OBJ 7//most-stred
EngStatic[7]=new TBudova();
EngStatic[7]->pojede[0]=FALSE;
EngStatic[7]->pojede[1]=FALSE;
EngStatic[7]->pojede[2]=FALSE;
EngStatic[7]->InitDam=0;//nejde znicit
if(FAILED(((TBudova *)EngStatic[7])->Load("3dmodely\\most.x")))
	return E_FAIL;
EngStatic[7]->typ=TYP_BUDOVA;
rect =new TFloatRect;
rect->left=-0.5f;
rect->right=-0.4f;
rect->top=-0.5f;
rect->bottom=0.5f;
((TBudova *)EngStatic[7])->Obrys.Add(rect);//pridam obrys budovy
rect =new TFloatRect;
rect->left=0.4f;
rect->right=0.5f;
rect->top=-0.5f;
rect->bottom=0.5f;
((TBudova *)EngStatic[7])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 8//most-kraj
EngStatic[8]=new TBudova();
EngStatic[8]->pojede[0]=FALSE;
EngStatic[8]->pojede[1]=FALSE;
EngStatic[8]->pojede[2]=FALSE;
EngStatic[8]->InitDam=0;//nejde znicit
if(FAILED(((TBudova *)EngStatic[8])->Load("3dmodely\\mostkraj.x")))
	return E_FAIL;
EngStatic[8]->typ=TYP_BUDOVA;
rect =new TFloatRect;
rect->left=-0.5f;
rect->right=-0.4f;
rect->top=-0.2f;
rect->bottom=0.5f;
((TBudova *)EngStatic[8])->Obrys.Add(rect);//pridam obrys budovy
rect =new TFloatRect;
rect->left=0.4f;
rect->right=0.5f;
rect->top=-0.2f;
rect->bottom=0.5f;
((TBudova *)EngStatic[8])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 9//sklad
EngStatic[9]=new TBudova();
EngStatic[9]->pojede[0]=FALSE;
EngStatic[9]->pojede[1]=FALSE;
EngStatic[9]->pojede[2]=FALSE;
EngStatic[9]->InitDam=3;
if(FAILED(((TBudova *)EngStatic[9])->Load("3dmodely\\sklad.x")))
	return E_FAIL;
EngStatic[9]->typ=TYP_BUDOVA;
rect =new TFloatRect;
rect->left=-0.5f;
rect->right=0.5f;
rect->top=-0.5f;
rect->bottom=0.5f;
((TBudova *)EngStatic[9])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 10//cerpaci stanice
EngStatic[10]=new TBudova();
EngStatic[10]->pojede[0]=FALSE;
EngStatic[10]->pojede[1]=FALSE;
EngStatic[10]->pojede[2]=FALSE;
EngStatic[10]->InitDam=3;
if(FAILED(((TBudova *)EngStatic[10])->Load("3dmodely\\benzin.x")))
	return E_FAIL;
EngStatic[10]->typ=TYP_BUDOVA;
rect =new TFloatRect;
rect->left=-0.5f;
rect->right=0.5f;
rect->top=-0.5f;
rect->bottom=0.5f;
((TBudova *)EngStatic[10])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 11//zed1
EngStatic[11]=new TBudova();
EngStatic[11]->pojede[0]=FALSE;
EngStatic[11]->pojede[1]=FALSE;
EngStatic[11]->pojede[2]=FALSE;
EngStatic[11]->InitDam=0;//neznic
if(FAILED(((TBudova *)EngStatic[11])->Load("3dmodely\\zed1.x")))
	return E_FAIL;
EngStatic[11]->typ=TYP_BUDOVA;
rect =new TFloatRect;
rect->left=-0.5f;
rect->right=0.5f;
rect->top=-0.1f;
rect->bottom=0.1f;
((TBudova *)EngStatic[11])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 12//zed2
EngStatic[12]=new TBudova();
EngStatic[12]->pojede[0]=FALSE;
EngStatic[12]->pojede[1]=FALSE;
EngStatic[12]->pojede[2]=FALSE;
EngStatic[12]->InitDam=0;//neznic
if(FAILED(((TBudova *)EngStatic[12])->Load("3dmodely\\zed2.x")))
	return E_FAIL;
EngStatic[12]->typ=TYP_BUDOVA;
rect =new TFloatRect;
rect->left=-0.1f;
rect->right=0.1f;
rect->top=-0.5f;
rect->bottom=0.5f;
((TBudova *)EngStatic[12])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 13//zed3
EngStatic[13]=new TBudova();
EngStatic[13]->pojede[0]=FALSE;
EngStatic[13]->pojede[1]=FALSE;
EngStatic[13]->pojede[2]=FALSE;
EngStatic[13]->InitDam=0;//neznic
if(FAILED(((TBudova *)EngStatic[13])->Load("3dmodely\\zed3.x")))
	return E_FAIL;
EngStatic[13]->typ=TYP_BUDOVA;
rect =new TFloatRect;
rect->left=-0.5f;
rect->right=0.5f;
rect->top=-0.1f;
rect->bottom=0.1f;
((TBudova *)EngStatic[13])->Obrys.Add(rect);//pridam obrys budovy
rect =new TFloatRect;
rect->left=-0.1f;
rect->right=0.1f;
rect->top=-0.5f;
rect->bottom=0.5f;
((TBudova *)EngStatic[13])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 14//vezicka
EngStatic[14]=new TBudova();
EngStatic[14]->pojede[0]=FALSE;
EngStatic[14]->pojede[1]=FALSE;
EngStatic[14]->pojede[2]=FALSE;
EngStatic[14]->InitDam=0;//nejde znicit
if(FAILED(((TBudova *)EngStatic[14])->Load("3dmodely\\vezicka.x")))
	return E_FAIL;
EngStatic[14]->typ=TYP_BUDOVA;
rect =new TFloatRect;
rect->left=-0.25f;
rect->right=0.25f;
rect->top=-0.25f;
rect->bottom=0.25f;
((TBudova *)EngStatic[14])->Obrys.Add(rect);//pridam obrys budovy
//OBJ 15//mina
EngStatic[15]=new TTStatic();
if(FAILED(((TTStatic *)EngStatic[15])->Load("mina.bmp",DDSD_CKSRCBLT)))
	return E_FAIL;
EngStatic[15]->typ=TYP_TSTATIC;
EngStatic[15]->range=0.1f;//doladit
EngStatic[15]->pojede[0]=TRUE;//projedou vsichni
EngStatic[15]->pojede[1]=TRUE;
EngStatic[15]->pojede[2]=TRUE;
EngStatic[15]->InitDam=0;//spec. vlastnosti - znici jen vrtulnik pomoci rakety!!!
((TTStatic *)EngStatic[15])->ScaleX=0.1f;
((TTStatic *)EngStatic[15])->ScaleY=0.1f;
//OBJ 16//ruiny benzinky a municniho skladu
EngStatic[16]=new TTStatic();
if(FAILED(((TTStatic *)EngStatic[16])->Load("ruiny.bmp",DDSD_CKSRCBLT)))
	return E_FAIL;
EngStatic[16]->typ=TYP_TSTATIC;
EngStatic[16]->range=0.0f;//doladit
EngStatic[16]->pojede[0]=TRUE;//projedou vsichni
EngStatic[16]->pojede[1]=TRUE;
EngStatic[16]->pojede[2]=TRUE;
((TTStatic *)EngStatic[16])->ScaleX=0.5f;
((TTStatic *)EngStatic[16])->ScaleY=0.5f;
//OBJ 17//rip
EngStatic[17]=new TTStatic();
if(FAILED(((TTStatic *)EngStatic[17])->Load("rip.bmp",DDSD_CKSRCBLT)))
	return E_FAIL;
EngStatic[17]->typ=TYP_TSTATIC;
EngStatic[17]->range=0.0f;//doladit
EngStatic[17]->pojede[0]=TRUE;//projedou vsichni
EngStatic[17]->pojede[1]=TRUE;
EngStatic[17]->pojede[2]=TRUE;
((TTStatic *)EngStatic[17])->ScaleX=0.2f;
((TTStatic *)EngStatic[17])->ScaleY=0.2f;
//OBJ 18//dira
EngStatic[18]=new TTStatic();
if(FAILED(((TTStatic *)EngStatic[18])->Load("dira.bmp",DDSD_CKSRCBLT)))
	return E_FAIL;
EngStatic[18]->typ=TYP_TSTATIC;
EngStatic[18]->range=0.0f;//doladit
EngStatic[18]->pojede[0]=TRUE;//projedou vsichni
EngStatic[18]->pojede[1]=TRUE;
EngStatic[18]->pojede[2]=TRUE;
EngStatic[18]->InitDam=0;
((TTStatic *)EngStatic[18])->ScaleX=0.2f;
((TTStatic *)EngStatic[18])->ScaleY=0.2f;
//.
//.
//.			
return S_OK;
}

/*HRESULT InitAnim()
{
return S_OK;//kazda animace se inicializuje individualne
}*///ted inicializace pod TStatic

HRESULT InitGameObjects()
{//predpoklada, ze neni nic inicializovane
EngCam.maxrych=1.0f;
if(FAILED(InitStatic()))
	return E_FAIL;
AutoModely=new CD3DFileObject[7];
for(int i=0;i<7;i++)
	{
	if(FAILED(AutoModely[i].Load(LoadHracModels[i])))
		return E_FAIL;
	}
StrelaModely=new CD3DFileObject[3];//tri typy strel
for(i=0;i<3;i++)
	{
	if(FAILED(StrelaModely[i].Load(LoadStrelaModels[i])))
		return E_FAIL;
	}
VlajModely=new CD3DFileObject[2];//ctyri typy vlajecek
for(i=0;i<2;i++)
	{
	if(FAILED(VlajModely[i].Load(LoadVlajModels[i])))
		return E_FAIL;
	}
return S_OK;
}

HRESULT DeInitGameObjects()
{
SAFE_DELETEARRAY(AutoModely);
SAFE_DELETEARRAY(StrelaModely);
SAFE_DELETEARRAY(VlajModely);

if(EngStatic)//deinit static
for(int i=0;i<LIM_STAT;i++)
	SAFE_DELETE(EngStatic[i]);
SAFE_DELETEARRAY(EngStatic);

return S_OK;
}


/***********renderovani interface***********/

HRESULT RenderInterface(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect )
{
D3DTLVERTEX PozadiMesh[4];
//                  (tohle se upravi. 
//0   1
//2   3

// Set up the dimensions for the background image
D3DVIEWPORT2 vp;
vp.dwSize = sizeof(vp);
pvViewport->GetViewport2(&vp);
PozadiMesh[0] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 0, 1 );
PozadiMesh[1] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 0, 0 );
PozadiMesh[2] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 1, 1 );
PozadiMesh[3] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 1, 0 );
/*
PozadiMesh[0].sy = (FLOAT)vp.dwHeight;
PozadiMesh[2].sy = (FLOAT)vp.dwHeight;
PozadiMesh[2].sx = (FLOAT)vp.dwWidth;
PozadiMesh[3].sx = (FLOAT)vp.dwWidth;
*///puvodni
PozadiMesh[0].sx = (FLOAT)vp.dwWidth/2.0f-64;
PozadiMesh[0].sy = (FLOAT)vp.dwHeight/2.0f+64;
PozadiMesh[1].sx = (FLOAT)vp.dwWidth/2.0f-64;
PozadiMesh[1].sy = (FLOAT)vp.dwHeight/2.0f-64;
PozadiMesh[2].sx = (FLOAT)vp.dwWidth/2.0f+64;
PozadiMesh[2].sy = (FLOAT)vp.dwHeight/2.0f+64;
PozadiMesh[3].sx = (FLOAT)vp.dwWidth/2.0f+64;
PozadiMesh[3].sy = (FLOAT)vp.dwHeight/2.0f-64;

//neco z toho neni treba (mam transformed and lit vertices!!
pd3dDevice->SetTexture( 0, EngIntMain->ptexTexture);
pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE,  FALSE );
pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHABLENDENABLE, FALSE );

pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_TLVERTEX,PozadiMesh,4,0/*D3DDP_WAIT*/);

return S_OK;
}

HRESULT RenderInterface2(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect,DWORD time)
{
static float Uhel[4]={0,0,0,0};
static float Zoom[4]={1,1,1,1};
static int Sel=0;//vyber
static DWORD dwOldKeys = 0;
static int WaitingTime;

EngSamoZnic=false;//pred dalsim vyjetim je nutne resetovat

gBasekaTime+=(float)time*0.001f;

/******reakce na klavesy******/


if(EngHaveACar)
	{
	SHIP ship;
	DWORD dwSize = sizeof(ship);
	HRESULT hr = DPlayGetPlayerData(gOurID, &ship, &dwSize, DPGET_LOCAL);
	if (FAILED(hr))
		return hr;
	ship.bEnable=TRUE;//dopichnout vylezani z podzemi INITOURSHIP
	ship.bPodzemi=FALSE;

	SetStartPosition(&ship);

	hr = DPlaySetPlayerData(gOurID, &ship, sizeof(ship), DPSET_LOCAL);
	if (FAILED(hr))
		return hr;

	EngHaveACar=false;//uz to nebude potreba
	EngActZbran=0;
	if(bWantSound)
		{//SNDPREDELAT
		SndObjPlay(hsoBeginLevel,0);
		}
	EngAppState=1;

	//synchronizovat s ostatnimi
	SendSync(&ship);
	dwOldKeys = gdwKeys;
	return S_OK;
	}
if(EngWaitOnCar)
	{
	WaitingTime-=time;
	if(WaitingTime<0)
		{//beep
		EngWaitOnCar=false;//prestavam cekat
		AddTextInfo("Cekani na auticko od serveru preruseno (timeout)");
		}
	dwOldKeys = gdwKeys;
	return S_OK;
	}

int sx=EngMapa->SizeX;
int sy=EngMapa->SizeY;

if(LocState==0)
	{//vyber auta
	if (((gdwKeys & KEY_FIRE1)||(gdwKeys & KEY_FIRE2))&&gBasekaTime>BASEKA_TIME)
		{
		if(!EngZdroj[EngDruzstvo].NCar[Sel])
			{//beep
			
			}
		else
			{
			if(gbIsHost)//lokalne
				{//ekvivalent pro nehosty v messages
				SHIP ship;//INITOURSHIP
				ZeroMemory(&ship, sizeof(ship));//dodelat SOUNDBUFFERS tak aby tohle nevadilo
				/******nastaveni auta******/
				ship.Typ=Sel;
				ship.byType=EngDruzstvo;
				EngZdroj[EngDruzstvo].NCar[Sel]--;
				ship.Fuel=FuelLimit[ship.Typ];
				ship.Ammo[0]=AmmoLimit[ship.Typ][0];
				ship.Ammo[1]=AmmoLimit[ship.Typ][1];
				ship.Damage=DamageLimit[ship.Typ];
				ship.Vlajecka=FALSE;
				ship.R=INIT_ANGLE;

				ship.bEnable=TRUE;//dopichnout vylezani z podzemi INITOURSHIP
				ship.bPodzemi=FALSE;
				SetStartPosition(&ship);
				EngActZbran=0;
				EngAppState=1;
				if(bWantSound)
					{//SNDPREDELAT
					SndObjPlay(hsoBeginLevel,0);
					}

				if(ship.Typ==3)
					{
					ship.Z=HELI_VYS;
					}
				else
				if(ship.Typ==2)
					{//miny omezene
					if(ship.Ammo[1]>EngZdroj[EngDruzstvo].NMina)
						ship.Ammo[1]=EngZdroj[EngDruzstvo].NMina;	
					EngZdroj[EngDruzstvo].NMina-=ship.Ammo[1];
					}
				HRESULT hr = DPlaySetPlayerData(gOurID, &ship, sizeof(ship), DPSET_LOCAL);
				if (FAILED(hr))
					return hr;
				/******sync zdroje*****/
				gSyncZdrojMsg.zdroje[0]=EngZdroj[0];
				gSyncZdrojMsg.zdroje[1]=EngZdroj[1];
				SendGameMessage((LPGENERICMSG) &gSyncZdrojMsg,DPID_ALLPLAYERS);

				//jeste treba synchronizovat
				SendSync(&ship);
				}
			else
				{//musim si auto vyzadat
				gZdrojeMsg.Host=false;
				gZdrojeMsg.What=Sel;
				gZdrojeMsg.Miny=0;//nema smysl
				gZdrojeMsg.Skup=EngDruzstvo;
				SendGameMessage((LPGENERICMSG) &gZdrojeMsg,DPID_ALLPLAYERS);
				EngWaitOnCar=true;
				WaitingTime=COMPETE_TIME;
				AddTextInfo("Program ceka na potvrzeni prevzeti auta od serveru...");
				}
			}
		}
	if ((gdwKeys & KEY_LEFT) && !(dwOldKeys & KEY_LEFT))
		{//doleva
		Sel--;
		if(Sel==-1||Sel==1)//korekce
			Sel+=2;
		}
	if ((gdwKeys & KEY_RIGHT) && !(dwOldKeys & KEY_RIGHT))
		{//doprava
		Sel++;
		if(Sel==2||Sel==4)//korekce
			Sel-=2;
		}
	if ((gdwKeys & KEY_FRONT) && !(dwOldKeys & KEY_FRONT))
		{//nahoru
		Sel-=2;
		if(Sel==-2||Sel==-1)//korekce
			Sel+=4;
		}
	if ((gdwKeys & KEY_BACK) && !(dwOldKeys & KEY_BACK))
		{//dolu
		Sel+=2;
		if(Sel==4||Sel==5)//korekce
			Sel-=4;
		}
	}
else if(LocState==1)//globalni mapka
	{//dodelat zoomovani atd.
	float t=(float)time/1000.0f;
	if(t>2.0f)t=2.0f;//kvuli pow a kvuli prilis rychlemu zoomu u trhanych systemu
	if((gdwKeys & KEY_FIRE2))
		{
		GlobZoom*=(float)pow(ZOOMSPEED,t);
		if(GlobZoom>MAP_RANGE)
			GlobZoom=MAP_RANGE;
		}
	if((gdwKeys & KEY_FIRE1))
		{
		GlobZoom/=(float)pow(ZOOMSPEED,t);
		if(GlobZoom<2.0f)
			GlobZoom=2.0f;
		}
	if((gdwKeys & KEY_LEFT))
		{
		GlobX-=GlobZoom*t;
		if(GlobX<0)GlobX=0;
		}
	if((gdwKeys & KEY_RIGHT))
		{
		GlobX+=GlobZoom*t;
		if(GlobX>sx)GlobX=(float)sx;
		}
	if((gdwKeys & KEY_FRONT))
		{
		GlobY-=GlobZoom*t;
		if(GlobY<0)GlobY=0;
		}
	if((gdwKeys & KEY_BACK))
		{
		GlobY+=GlobZoom*t;
		if(GlobY>sy)GlobY=(float)sy;
		}
	}

if(LocState==0)
for(int i=0;i<4;i++)//update uhly
	{
	Uhel[i]+=(float)time/8000.0f;//vsechny se toci
	if(i==Sel)
		Uhel[i]+=(float)time/500.0f;//vsechny se toci, ale vybrany nejvic
	if(Uhel[i]>g_2_PI)Uhel[i]-=g_2_PI;
	else if(Uhel[i]<0)Uhel[i]+=g_2_PI;//korekce uhlu

	if(Sel==i)
		Zoom[i]+=(float)time/500.0f;
	else
		Zoom[i]-=(float)time/500.0f;
	if(Zoom[i]<1)
		Zoom[i]=1;
	else if(Zoom[i]>2.0f)
		Zoom[i]=2.0f;
	}


D3DTLVERTEX PozadiMesh[4];
//                  (tohle se upravi. 
//0   1
//2   3

// Set up the dimensions for the background image
D3DVIEWPORT2 vp;
vp.dwSize = sizeof(vp);
pvViewport->GetViewport2(&vp);
if(DEMOmapvis&&LocState==0)
	{
	PozadiMesh[0] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 0, 1 );
	PozadiMesh[1] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 0, 0 );
	PozadiMesh[2] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 1, 1 );
	PozadiMesh[3] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 1, 0 );
	
/*	PozadiMesh[0].sy = (FLOAT)vp.dwHeight;
	PozadiMesh[2].sy = (FLOAT)vp.dwHeight;
	PozadiMesh[2].sx = (FLOAT)vp.dwWidth;
	PozadiMesh[3].sx = (FLOAT)vp.dwWidth;*/	//puvodni


	PozadiMesh[0].sx = (FLOAT)vp.dwWidth/2.0f-128;
	PozadiMesh[0].sy = (FLOAT)vp.dwHeight/2.0f+128;
	PozadiMesh[1].sx = (FLOAT)vp.dwWidth/2.0f-128;
	PozadiMesh[1].sy = (FLOAT)vp.dwHeight/2.0f-128;
	PozadiMesh[2].sx = (FLOAT)vp.dwWidth/2.0f+128;
	PozadiMesh[2].sy = (FLOAT)vp.dwHeight/2.0f+128;
	PozadiMesh[3].sx = (FLOAT)vp.dwWidth/2.0f+128;
	PozadiMesh[3].sy = (FLOAT)vp.dwHeight/2.0f-128;

	//neco z toho neni treba (mam transformed and lit vertices!!
	pd3dDevice->SetTexture( 0, EngPodTex->ptexTexture);
	pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
	pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE,  FALSE );
	pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHABLENDENABLE, FALSE );

	pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_TLVERTEX,PozadiMesh,4,0/*D3DDP_WAIT*/);
	}
if(LocState==1)
	{
	PozadiMesh[0] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 0, 1 );
	PozadiMesh[1] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 0, 0 );
	PozadiMesh[2] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 1, 1 );
	PozadiMesh[3] = D3DTLVERTEX( D3DVECTOR(0,0,0.99f), 0.5f, -1, 0, 1, 0 );
	
	//neco z toho neni treba (mam transformed and lit vertices!!
	pd3dDevice->SetTextureStageState( 0, D3DTSS_ADDRESS, D3DTADDRESS_MIRROR );//nove

	pd3dDevice->SetTextureStageState( 0, D3DTSS_MINFILTER, D3DTFN_LINEAR );
	pd3dDevice->SetTextureStageState( 0, D3DTSS_MAGFILTER, D3DTFG_LINEAR );
	pd3dDevice->SetRenderState( D3DRENDERSTATE_DITHERENABLE, TRUE );

	pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,  D3DTOP_DISABLE );
	pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHATESTENABLE,  FALSE );
	pd3dDevice->SetRenderState( D3DRENDERSTATE_ALPHABLENDENABLE, FALSE );

	int fromx=(int)(GlobX-GlobZoom);
	int fromy=(int)(GlobY-GlobZoom*(FLOAT)vp.dwHeight/(FLOAT)vp.dwWidth);
	int tox=(int)(GlobX+GlobZoom);
	int toy=(int)(GlobY+GlobZoom*(FLOAT)vp.dwHeight/(FLOAT)vp.dwWidth);

	float x1,x2,y1,y2;
	float koef=(FLOAT)vp.dwWidth/(GlobZoom*2.0f);
	
	for(int y=fromy;y<=toy;y++)
	for(int x=fromx;x<=tox;x++)
		{
		x1=(FLOAT)vp.dwWidth/2.0f+(x-GlobX)*koef;
		x2=(FLOAT)vp.dwWidth/2.0f+(x-GlobX+1)*koef;
		y1=(FLOAT)vp.dwHeight/2.0f+(y-GlobY)*koef;
		y2=(FLOAT)vp.dwHeight/2.0f+(y-GlobY+1)*koef;

		PozadiMesh[0].sx = x1;
		PozadiMesh[0].sy = y2;
		PozadiMesh[1].sx = x1;
		PozadiMesh[1].sy = y1;
		PozadiMesh[2].sx = x2;
		PozadiMesh[2].sy = y2;
		PozadiMesh[3].sx = x2;
		PozadiMesh[3].sy = y1;

		if(x>=0&&x<sx&&y>=0&&y<sy)
			{
			pd3dDevice->SetTexture(0,EngMapaTextury[EngMapa->Mapa[x+y*sx].Podklad]->ptexTexture);
			pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_TLVERTEX,PozadiMesh,4,0/*D3DDP_WAIT*/);
			}
		}
	//ted vykresli auticka
	PozadiMesh[0] = D3DTLVERTEX( D3DVECTOR(0,0,0), 0.5f, -1, 0, 0, 1 );
	PozadiMesh[1] = D3DTLVERTEX( D3DVECTOR(0,0,0), 0.5f, -1, 0, 0, 0 );
	PozadiMesh[2] = D3DTLVERTEX( D3DVECTOR(0,0,0), 0.5f, -1, 0, 1, 1 );
	PozadiMesh[3] = D3DTLVERTEX( D3DVECTOR(0,0,0), 0.5f, -1, 0, 1, 0 );//kvuli z bufferu

	pd3dDevice->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE,TRUE);

	float mark=32.0f;

	for(int i=0;i<PlayerCount;i++)
		{
		if(PlayerBuf[i].bEnable)
			{//jeste je videt
			pd3dDevice->SetTexture(0,RadTex[PlayerBuf[i].Typ+((EngDruzstvo==PlayerBuf[i].byType) ? 0 : 4 )]->ptexTexture);

			x1=(FLOAT)vp.dwWidth/2.0f+(PlayerBuf[i].X-GlobX)*koef-mark;
			x2=(FLOAT)vp.dwWidth/2.0f+(PlayerBuf[i].X-GlobX)*koef+mark;
			y1=(FLOAT)vp.dwHeight/2.0f+(PlayerBuf[i].Y-GlobY)*koef-mark;
			y2=(FLOAT)vp.dwHeight/2.0f+(PlayerBuf[i].Y-GlobY)*koef+mark;

			PozadiMesh[0].sx = x1;
			PozadiMesh[0].sy = y2;
			PozadiMesh[1].sx = x1;
			PozadiMesh[1].sy = y1;
			PozadiMesh[2].sx = x2;
			PozadiMesh[2].sy = y2;
			PozadiMesh[3].sx = x2;
			PozadiMesh[3].sy = y1;

			pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_TLVERTEX,PozadiMesh,4,0/*D3DDP_WAIT*/);
	//		pd3dDevice->DrawPrimitive(D3DPT_TRIANGLESTRIP,D3DFVF_VERTEX,Policko,4,0/*D3DDP_WAIT*/);
			}
		}
	pd3dDevice->SetRenderState(D3DRENDERSTATE_COLORKEYENABLE,FALSE);
	}
/*******ted to vykresli auticka******/
if(LocState==0)
	{
	float k=0.8f;
	float PolohaX[4]={k*1.4f,-k*1.4f,k*1.4f,-k*1.4f};
	float PolohaY[4]={k,k,-k,-k};
	float PolohaZ[4]={k,k,-k,-k};
	SHIP ship;
	ZeroMemory( &ship, sizeof(SHIP) );
	ship.byType=EngDruzstvo;
	for(int i=0;i<4;i++)
		{
		ship.Typ=i;
		ship.R=Uhel[i];
		ship.RVrt1=ship.RVrt2=ship.R;
		if(ship.Typ==0)
			{//jeep
			ship.RVrt1=0;
			}
		ship.X=PolohaX[i];
		ship.Y=PolohaY[i];
		ship.Z=PolohaZ[i];
		TCar *car=MakeCar(&ship);

		car->zoom=Zoom[i];
		car->Display(pd3dDevice,0);
		car->zoom=0;
		}
	}
dwOldKeys = gdwKeys;
return S_OK;
}


HRESULT ComputeGame()
{
HRESULT hr;
TStatSpoj *obj;
static float CerpStrel=0.0f;//kvuli doplnovani streliva kazdou celou sekundu!

DWORD dwCurTime=timeGetTime();
static DWORD dwLastZasekSync=0;

int fromx;
int fromy;
int tox;
int toy;
int sx=EngMapa->SizeX;
int sy=EngMapa->SizeY;

float X;//pozice vozidla
float Y;
float R;//natoceni

//---------pohyb aut
//vyplnim pole hracu se kterymi budu pocitat

PlayerCount=0;
EngPocetHracu[0]=0;
EngPocetHracu[1]=0;//ted budeme v computeplayerCB je pocitat!
EngPocetEnabHracu[0]=0;
EngPocetEnabHracu[1]=0;//ted budeme v computeplayerCB je pocitat!
if(FAILED(DPlayEnumPlayers(NULL, ComputePlayerCB, NULL, 0)))
	{
	ShowError(IDS_DPLAY_ERROR_EP);
	return E_FAIL;
	}


if(gbIsHost)//info o konci zdroju
	{
	int i;
	for(int dr=0;dr<2;dr++)
		{
		if(EngEnd[dr]||EngPocetEnabHracu[dr])//uz jsem informoval
			continue;
		for(i=0;i<4;i++)
			if(EngZdroj[dr].NCar[i])
				break;
		if(i==4)
			{//nenaslo to zadna auta
			EngEnd[dr]=true;			
			gScoreMsg.score[0]=0;
			gScoreMsg.score[1]=0;
			gScoreMsg.zmena[0]=0;//pouze info o nedostatku aut
			gScoreMsg.zmena[1]=0;
			gScoreMsg.zmena[dr]--;
			SendGameMessage((LPGENERICMSG) &gScoreMsg,DPID_ALLPLAYERS);
			/*****ted jeste informovat textem sam sebe******/
			if(EngDruzstvo==dr)
				{
				AddTextInfo(">>>Uz nemate zadna auticka<<<");
				}
			else
				{
				AddTextInfo(">>>Druhe druzstvo uz nema zadna auticka<<<");
				}
			}
		}
	}

//update bitkatime
gBitkaTime+=ComputeCBTime*0.001f;
/*******move strely***************/
TStrela *strela;
EngSStrely->Reset();
while(strela=EngSStrely->Next())
	{//projdu vsechny letici strely
	strela->Move(ComputeCBTime*0.001f);//pohnise strelou
	}
/**********compute hrace*********/
for(int i=0;i<PlayerCount;i++)
	{//projde vsechny nalezene hrace
	TCar *car;
  
    // ignore current ship ?
    if (PlayerBuf[i].bIgnore)
    {
        continue;
    }

    // bail, if ship is disabled
    if (!PlayerBuf[i].bEnable) continue;

	// update ship's position
	//UpdatePosition(dpId, &ship);//nove zruseno, ted move
	car=MakeCar(&PlayerBuf[i]);
	if(PlayerPID[i]!=gOurID)
		{//ghost..nepocitat kolize, prijdou po siti
		car->Move(PlayerBuf[i].dwKeys,ComputeCBTime*0.001f);
		if(PlayerBuf[i].NextSyncTime>0)
			PlayerBuf[i].NextSyncTime-=ComputeCBTime;
		}
	if(PlayerPID[i]==gOurID&&EngAppState==1)//jsem na povrchu
		{//jsem to ja -> kontrola srazky se statickymi objekty
		if(((PlayerBuf[i].Typ==1||PlayerBuf[i].Typ==2)&&SUCCEEDED(VeVode(PlayerBuf[i].X,PlayerBuf[i].Y)))||(PlayerBuf[i].Fuel<=0&&PlayerBuf[i].Typ==3)||EngSamoZnic)
			{//smrt pro nejeep ve vode
			//nebo smrt pro helikopteru bez paliva
			//nebo samozniceni
			DestroyShip(&PlayerBuf[i]);//dodelat
			EngAppState=2;//podzemi//UMIRAM na utopeni
			EngUmiram=1;
			gBasekaTime=0;

			AddTextInfo("Prave jsi prisel o vozitko");
			if(bWantSound)//final2, zvuk exploze
				{//SNDPREDELAT
				SndObjStop(hsoExplode);
				SndObjPlay(hsoExplode,0);
				}
			
			PlayerBuf[i].dwLastTick = timeGetTime();
			// let the world know that we are dead
			gShipHitMsg.Id = gOurID;
			SendGameMessage((LPGENERICMSG) &gShipHitMsg, DPID_ALLPLAYERS);
			}
		//zalozni data pro pripad kolize
		hr=E_FAIL;

		X=car->share->X;
		Y=car->share->Y;
		R=car->share->R;
		car->Move(PlayerBuf[i].dwKeys,ComputeCBTime*0.001f);

		fromx=(int)X-2;
		fromy=(int)Y-2;
		tox=(int)X+2;
		toy=(int)Y+2;//doladit rezervy podle velikosti statickych objektu

		if(fromx<0)fromx=0;//abych nevylezl z mapky!!
		if(fromy<0)fromy=0;//abych nevylezl z mapky!!
		if(tox>=sx)tox=sx-1;//abych nevylezl z mapky!!
		if(toy>=sy)toy=sy-1;//abych nevylezl z mapky!!

		int	x,y;
		BOOL Prejed=FALSE;
		BOOL Zastav=FALSE;
		BOOL Cerp=false;
		for(y=fromy;y<=toy;y++)//ANALOGIE NIZE
			{
			for(x=fromx;x<=tox;x++)
				{//projdu prilehle policka mapky
				EngMapa->Mapa[x+y*sx].Spojak->Reset();
				while(obj=EngMapa->Mapa[x+y*sx].Spojak->Next())
					{
					/****docerpavani paliva a streliva**********/
					if(obj->Index==10&&_hypot((float)x+obj->X-PlayerBuf[i].X,(float)y+obj->Y-PlayerBuf[i].Y)<CERP_LEN)//vzdalenost doladit
						{//cerpam palivo
						PlayerBuf[i].Fuel+=CERP_PALIVO*ComputeCBTime*0.001f;
						if(PlayerBuf[i].Fuel>FuelLimit[PlayerBuf[i].Typ])
							PlayerBuf[i].Fuel=FuelLimit[PlayerBuf[i].Typ];
						}
					if(obj->Index==9&&_hypot((float)x+obj->X-PlayerBuf[i].X,(float)y+obj->Y-PlayerBuf[i].Y)<CERP_LEN)//vzdalenost doladit
						{//cerpam strelivo
						Cerp=true;
						CerpStrel+=ComputeCBTime*0.001f;
						if(CerpStrel>1.0f)
							{
							PlayerBuf[i].Ammo[0]+=CERP_STRELIVO;//spec. postup pro cela cisla
							if(PlayerBuf[i].Ammo[0]>AmmoLimit[PlayerBuf[i].Typ][0])
								PlayerBuf[i].Ammo[0]=AmmoLimit[PlayerBuf[i].Typ][0];
							if(PlayerBuf[i].Typ!=2)//armo - miny nedoplnovat (ucelne omezena v cele hre, at je zabava)
								{
								PlayerBuf[i].Ammo[1]+=CERP_STRELIVO;//spec. postup pro cela cisla
								if(PlayerBuf[i].Ammo[1]>AmmoLimit[PlayerBuf[i].Typ][1])
									PlayerBuf[i].Ammo[1]=AmmoLimit[PlayerBuf[i].Typ][1];
								CerpStrel-=1.0f;
								}
							}
						}
					/****konec cerp pal/strel********/
					hr=car->Kolize(obj,(float)x,(float)y);
					if(hr==S_OK)
						Prejed=TRUE;
					else if(hr==E_ACCESSDENIED)
						{
						if(obj->Index==14&&car->share->Typ==0)//vezicka, pokud nemam vlajecku a mam jeep, tak si ji vezmu
							{
							car->share->Vlajecka=true;
							}
						Zastav=TRUE;
						}
					if(Prejed&&Zastav)
						break;
					}
				if(Prejed&&Zastav)
					break;
				}
			if(Prejed&&Zastav)
				break;
			}
		if(!Cerp)
			{//necerpam -> vynuluj citac casu cerpani
			CerpStrel=0.0f;
			}
		if(Zastav)
			{//nemuzu to projet
			car->share->X=X;
			car->share->Y=Y;
			car->share->R=R;
			car->share->rych=0;//a zastav
			SendSync(car->share);//oznam to druhym hracum
			}
		else
		//ted kontrola kolizi s jinymi vozidly
			for(int v=0;v<PlayerCount;v++)
				{//projde vsechny nalezene hrace
				// ignore current ship ?
				if (PlayerBuf[v].bIgnore)
					continue;
				// bail, if ship is disabled
				if (!PlayerBuf[v].bEnable)
					continue;

				if(PlayerPID[v]!=gOurID)//kolize sam se sebou nepocitej
					{
					TCar *car2;
					car2=MakeCar2(&PlayerBuf[v]);
					
					if(SUCCEEDED(car->Kolize(car2)))
						{				
						//zrusit desync
						car->share->deSyncR=0;//mira uhlove desynchronizace
						car->share->deSyncX=0;
						car->share->deSyncY=0;//mira prostorove desynchronizace
						car->share->NextSyncTime=0;//cas do dalsi predpokladane synchronizace v 
						//a zpracuj zaseknuti odseknuti
						if(car->share->rych!=0)
							{
							car->share->X=X;
							car->share->Y=Y;
							car->share->R=R;//casem se to muze trohu predelat (aby se pri narazu nemuseli zastavovat)
							car->share->rych=0;//a zastav
							}
						else
							{//system proti zaseknuti aut do sebe
							float vx,vy;
							vx=car->share->X-car2->share->X;
							vy=car->share->Y-car2->share->Y;
							float h=(float)_hypot(vx,vy);
							if(h>0.0001)
								{//jinak maji smulu
								vx/=h;
								vy/=h;//jednotkovy vektor
								car->share->X+=vx*ComputeCBTime/4000.0f;//za 1s se posunou o 0.25
								car->share->Y+=vy*ComputeCBTime/4000.0f;//za 1s se posunou o 0.25
								//ted kontrola, zda jsme se nenavezli do nejakeho objektu
								Zastav=FALSE;//ANALOGIE VYSE
								for(y=fromy;y<=toy;y++)
									{
									for(x=fromx;x<=tox;x++)
										{//projdu prilehle policka mapky
										EngMapa->Mapa[x+y*sx].Spojak->Reset();
										while(obj=EngMapa->Mapa[x+y*sx].Spojak->Next())
											{
											hr=car->Kolize(obj,(float)x,(float)y);
											if(hr==S_OK||hr==E_ACCESSDENIED)
												Zastav=TRUE;
											if(Zastav)
												break;
											}
										if(Zastav)
											break;
										}
									if(Zastav)
										{//nejde se vyseknout
										car->share->X=X;
										car->share->Y=Y;
										break;
										}
									}
								}
							}
						//je to potreba obcas sesynchronizovat
						if((dwCurTime - dwLastZasekSync) > SYNCZASEK_INTERVAL)
							{
							SendSync(car->share);//oznam to druhym hracum
							dwLastZasekSync = dwCurTime;
							}
						}						
					}
				}
		if(Prejed)//detekoval jsem objekt ktery musim rozjet
			for(y=fromy;y<=toy;y++)//projit na S_OK
				{
				for(x=fromx;x<=tox;x++)
					{//projdu prilehle policka mapky
					//update vsechny
					EngMapa->Mapa[x+y*sx].Spojak->Reset();
					while(obj=EngMapa->Mapa[x+y*sx].Spojak->Next())
						{
						hr=car->Kolize(obj,(float)x,(float)y);
						if(hr==S_OK)//auto-roz
							{//uz jsem ho nasel
							if(obj->Index==0)
								{//strom --- dopichnout ostatni staticke 
								/****informuj ostatni****/
								SendChangeMess(obj,x,y,-1);//-1 znamena, ze je objekt rozjet a ne sestrelen

								obj->Index=1;//upravy
								}
							else 
							if(obj->Index==15)//reakce na minu
								{//mina
								if(timeGetTime()-obj->dw_t<AKTIVACEMINY_TIME)
									{//ignorovat neaktivovane miny
									continue;
									}
								// explode the ship on our screen
								DestroyShip(&PlayerBuf[i]);//dodelat
								EngAppState=2;//podzemi UMIRAM na minu
								EngUmiram=1;
								gBasekaTime=0;
								
								AddTextInfo("Prave jsi prisel o vozitko");
								if(bWantSound)//final2, zvuk exploze
									{//SNDPREDELAT
									SndObjStop(hsoExplode);
									SndObjPlay(hsoExplode,0);
									}
								
								PlayerBuf[i].dwLastTick = timeGetTime();
								// let the world know that we are dead
								gShipHitMsg.Id = gOurID;
								SendGameMessage((LPGENERICMSG) &gShipHitMsg, DPID_ALLPLAYERS);

								SendChangeMess(obj,x,y,-1);//zmeny na mapce

								obj->Index=18;//upravy
								}
							//vybruslit z cyklu
							break;
							}
						}
					}
				}
		}//konec vypoctu kolizi meho auta se statickymi prekazkami

	//kontrola kolize strely s timto vozidlem
	if(!PlayerBuf[i].bPodzemi&&PlayerPID[i]!=gOurID)//pouze pokud je car na povrchu (predelat-> casem aktivni jen na povrchu!)
		{//a nesmim to byt ja
		EngSStrely->Reset();
		while(strela=EngSStrely->Next())
			{//projdu vsechny letici strely
			if(strela->gid.pid!=gOurID)
				continue;//neni to strela od nas -> nepocitej kolize
			hr=car->Hit(strela);
			if(hr==S_OK)//dodelat damage (i v doappmess..)
				{
				//info ost. hracum o zniceni strely
				gDelStrelaMsg.gid = strela->gid;
				gShipHitMsg.Dam = SilaStrely[strela->Typ];//mira poskozeni

				SendGameMessage((LPGENERICMSG) &gDelStrelaMsg, DPID_ALLPLAYERS);
		
				EngSStrely->Delete();//smazat tu strelu

				//info
				gShipHitMsg.Id = PlayerPID[i];//new dodelat msg pro sestreleni lodi
				SendGameMessage((LPGENERICMSG) &gShipHitMsg, PlayerPID[i]);
				}
			}
		}
	}//end of for(.;.;.)

/*******uloz updatnute udaje******/
for(i=0;i<PlayerCount;i++)
	{//projde vsechny nalezene hrace a ulozi jejich aktualizovana data
		// save ship data
	hr = DPlaySetPlayerData(PlayerPID[i], &PlayerBuf[i], sizeof(SHIP), DPSET_LOCAL);
    if (FAILED(hr))
	    {
		TRACE(TEXT("Set Player local data failed for id %d\n"), PlayerPID[i]);
//		return E_FAIL;//tohle mozna zrusit (kdyz se hrac odhlasi behem vypoctu, tak to muze hlasit invalidplayer)
		}
	}


//kontrola zasazeni statickeho objektu
EngSStrely->Reset();
while(strela=EngSStrely->Next())
	{//projdu vsechny letici strely
	if(strela->gid.pid!=gOurID)
		continue;//neni to strela od nas -> nepocitej kolize

	X=strela->X;
	Y=strela->Y;

	fromx=(int)X-1;
	fromy=(int)Y-1;
	tox=(int)X+1;
	toy=(int)Y+1;

	if(fromx<0)fromx=0;//abych nevylezl z mapky!!
	if(fromy<0)fromy=0;//abych nevylezl z mapky!!
	if(tox>=sx)tox=sx-1;//abych nevylezl z mapky!!
	if(toy>=sy)toy=sy-1;//abych nevylezl z mapky!!

	hr=E_FAIL;
	BOOL zasahl=FALSE;
	int zniceno=0;//celkem zniceno objektu
	for(int y=fromy;y<=toy;y++)
		{
		for(int x=fromx;x<=tox;x++)
			{//projdu prilehle policka mapky
			EngMapa->Mapa[x+y*sx].Spojak->Reset();
			while(obj=EngMapa->Mapa[x+y*sx].Spojak->Next())
				{
				if(EngStatic[obj->Index])
					{
					if(obj->Index==7||obj->Index==8)
						{//ignorovat mosty
						continue;
						}
					if(obj->Index==15&&(strela->From!=3||strela->Typ!=1))//mina jde sestrelit jen heli raketou
						{
						continue;
						}
					hr=EngStatic[obj->Index]->Hit(strela,(float)x+obj->X,(float)y+obj->Y,obj->R);//musim predat i souradnice x,y, kde se stat nachazi (absolutni)
					if(hr==S_OK)
						{//strela-hit
						if(obj->Index==11||obj->Index==12||obj->Index==13||obj->Index==14)
							{//neznicitelne budovy
							zniceno++;//strela znicena, ale objekt neporusen
							continue;
							}
						obj->Damage-=SilaStrely[strela->Typ];
						if(obj->Damage>=0)/****informuj ostatni****/
							{
							SendChangeMess(obj,x,y,strela->Typ);//pouze upravit damage
							zniceno++;//strela znicena, ale objekt jeste stoji
							break;
							}
						else
							{
							zniceno++;
							SendChangeMess(obj,x,y,-1);//okamzite znicit
							if(obj->Index==0)//TOTEZ bude u zpracovavani zprav o zmene stat objektu
								{//strom
								obj->Index=1;//upravy
								}
							else
							if(obj->Index==2)
								{//chaloupka
								obj->Index=3;//upravy
								}
							else
							if(obj->Index==4)
								{//barak
								obj->Index=5;//upravy
								obj->Damage=EngStatic[obj->Index]->InitDam;//inicializovat nove damage
								}
							else
							if(obj->Index==5)
								{//polozriceny barak
								obj->Index=6;//upravy
								}
							else
							if(obj->Index==9)
								{//munice
								obj->Index=16;//upravy
								}
							else
							if(obj->Index==10)
								{//munice
								obj->Index=16;//upravy
								}
							else
							if(obj->Index==15)
								{//mina
								obj->Index=18;//upravy
								}
	/*						else
								{
								zasahl=FALSE;
								zniceno--;
								}*///jistota, kdyz nekdo zvora specifikaci niceni objektu
							break;
							}
						}
					}
				}
			}
		}
	if(zniceno)//napocital jsem nejake vybuchy
		{
		//info ost. hracum
		gDelStrelaMsg.gid = strela->gid;
        SendGameMessage((LPGENERICMSG) &gDelStrelaMsg, DPID_ALLPLAYERS);

		EngSStrely->Delete();//smazat tu strelu
		}
	else //ztrela nebyla znicena vybuchem
		if(strela->Dolet<=0)
			{//strele vyprsela zivotnost
			//info ost. hracum
			gDelStrelaMsg.gid = strela->gid;
			SendGameMessage((LPGENERICMSG) &gDelStrelaMsg, DPID_ALLPLAYERS);

			EngSStrely->Delete();
			}
	}
/*

HRESULT hr=E_FAIL;
int fromx;
int fromy;
int tox;
int toy;
int sx=EngMapa->SizeX;
int sy=EngMapa->SizeY;

float X;//pozice vozidla
float Y;
float R;//natoceni

if(EngNearestTime==abstime)
	{
	TZmena *zmena;
	EngDynam->Reset();
	while(zmena=EngDynam->Next())
		{//zde projdu vsechny dynamicke zmeny a 'soucasne' provedu
		if(zmena->intime==abstime)
			{//je nacase
			if(zmena->op)
				{//pridat do mapky
				TStatSpoj *novy=new TStatSpoj;
				memcpy(novy,&(zmena->obj),sizeof(TStatSpoj));//vyplneni novy
				EngMapa->Mapa[zmena->mx+zmena->my*sx].Spojak->Add(novy);
				}
			else
				{//odebrat z mapky
				TStatSpoj *del;
				EngMapa->Mapa[zmena->mx+zmena->my*sx].Spojak->Reset();
				while(del=EngMapa->Mapa[zmena->mx+zmena->my*sx].Spojak->Next())
					{
					if(!memcmp(del,&(zmena->obj),sizeof(TStatSpoj)))
						{//je to ono
						EngMapa->Mapa[zmena->mx+zmena->my*sx].Spojak->Delete();
						break;//staci smazat jen jeden
						}
					}
				}
			EngDynam->Delete();//provedene smazat
			}
		}
	}

TStatSpoj *obj;
if(EngActCar)//moje auto na scene
	{
	//zalozni data pro pripad kolize
	X=EngActCar->X;
	Y=EngActCar->Y;
	R=EngActCar->R;
	EngActCar->Move(0,0,0,0,0,0,time*0.001f);//predam cas v sekundach

	fromx=(int)X-1;
	fromy=(int)Y-1;
	tox=(int)X+1;
	toy=(int)Y+1;

	if(fromx<0)fromx=0;//abych nevylezl z mapky!!
	if(fromy<0)fromy=0;//abych nevylezl z mapky!!
	if(tox>=sx)tox=sx-1;//abych nevylezl z mapky!!
	if(toy>=sy)toy=sy-1;//abych nevylezl z mapky!!

	int x,y;
	HRESULT kol=E_FAIL;//zadna kolize
	for(y=fromy;y<=toy;y++)
		{
		for(x=fromx;x<=tox;x++)
			{//projdu prilehle policka mapky
			EngMapa->Mapa[x+y*sx].Spojak->Reset();
			while(obj=EngMapa->Mapa[x+y*sx].Spojak->Next())
				{
				hr=EngActCar->Kolize(obj,(float)x,(float)y);
				if(hr!=E_FAIL)//pokud kolize
					kol=hr;
				if(kol==E_ACCESSDENIED)
					break;//neprojedu
				}
			if(kol==E_ACCESSDENIED)
				break;//neprojedu
			}
		if(kol==E_ACCESSDENIED)
			break;//neprojedu
		}
	if(kol==E_ACCESSDENIED)
		{//nemuzu to projet
		EngActCar->X=X;
		EngActCar->Y=Y;
		EngActCar->R=R;
		EngActCar->rych=0;//a zastav
		}
	else if(kol==S_OK)
		{//kolize ale muzu ji projet >> dopichnout zmenu stat objektu 'na placku'
		for(y=fromy;y<=toy;y++)//DEMO
			{
			for(x=fromx;x<=tox;x++)
				{//projdu prilehle policka mapky
				EngMapa->Mapa[x+y*sx].Spojak->Reset();
				while(obj=EngMapa->Mapa[x+y*sx].Spojak->Next())
					{
					hr=EngActCar->Kolize(obj,(float)x,(float)y);
					if(hr==S_OK)
						{//uz jsem ho nasel
						if(obj->Index==0)
							{//strom
							TStatSpoj *novy=new TStatSpoj;
							*novy=*obj;//prekopiruj obsah
							novy->Index=1;//upravy
							EngMapa->Mapa[x+y*sx].Spojak->Delete();
							EngMapa->Mapa[x+y*sx].Spojak->Add(novy);
							}
						//vybruslit z cyklu
						x=tox;
						y=toy;
						break;
						}
					}
				}
			}
		}//do de la t, predelat, DEMO, zrusit (zmenit vsechny objekty se kterymi koliduji a ne jen jeden
	}	 // na ktery jsem narazil prvni
//-------pohyb strel
//TSpojak <TStrela> *EngSStrely=NULL;//spojak vsech leticich strel
TStrela *strela;
EngSStrely->Reset();
while(strela=EngSStrely->Next())
	{//projdu vsechny letici strely
	if(EngActCar)//kontrola pohnutych aut
		{
		hr=EngActCar->Hit(strela);
		if(hr==S_OK)
			{//do de lat zasazeni cile
			}
		}
	strela->Move(time*0.001f);//pohnise strelou
	if(EngActCar)//opet kontrola aut po pohnuti strely
		{
		hr=EngActCar->Hit(strela);
		if(hr==S_OK)
			{//do de lat zasazeni cile
			}
		}
	//kontrola zasazeni statickeho objektu
	X=strela->X;
	Y=strela->Y;

	fromx=(int)X-1;
	fromy=(int)Y-1;
	tox=(int)X+1;
	toy=(int)Y+1;

	if(fromx<0)fromx=0;//abych nevylezl z mapky!!
	if(fromy<0)fromy=0;//abych nevylezl z mapky!!
	if(tox>=sx)tox=sx-1;//abych nevylezl z mapky!!
	if(toy>=sy)toy=sy-1;//abych nevylezl z mapky!!

	hr=E_FAIL;
	for(int y=fromy;y<=toy;y++)
		{
		for(int x=fromx;x<=tox;x++)
			{//projdu prilehle policka mapky
			EngMapa->Mapa[x+y*sx].Spojak->Reset();
			while(obj=EngMapa->Mapa[x+y*sx].Spojak->Next())
				{
				if(EngStatic[obj->Index])
					{
					hr=EngStatic[obj->Index]->Hit(strela,(float)x+obj->X,(float)y+obj->Y,obj->R);//musim predat i souradnice x,y, kde se stat nachazi (absolutni)
					if(hr==S_OK)
						{//zasah, DEMO
						if(obj->Index==0)
							{//strom
							TStatSpoj *novy=new TStatSpoj;
							*novy=*obj;//prekopiruj obsah
							novy->Index=1;//upravy
							EngMapa->Mapa[x+y*sx].Spojak->Delete();
							EngMapa->Mapa[x+y*sx].Spojak->Add(novy);
							EngSStrely->Delete();//smazat tu strelu
							}
						else
						if(obj->Index==2)
							{//chaloupka
							TStatSpoj *novy=new TStatSpoj;
							*novy=*obj;//prekopiruj obsah
							novy->Index=3;//upravy
							EngMapa->Mapa[x+y*sx].Spojak->Delete();
							EngMapa->Mapa[x+y*sx].Spojak->Add(novy);
							EngSStrely->Delete();//smazat tu strelu
							}
						else
						if(obj->Index==4)
							{//chaloupka
							TStatSpoj *novy=new TStatSpoj;
							*novy=*obj;//prekopiruj obsah
							novy->Index=5;//upravy
							EngMapa->Mapa[x+y*sx].Spojak->Delete();
							EngMapa->Mapa[x+y*sx].Spojak->Add(novy);
							EngSStrely->Delete();//smazat tu strelu
							}
						else
						if(obj->Index==5)
							{//chaloupka
							TStatSpoj *novy=new TStatSpoj;
							*novy=*obj;//prekopiruj obsah
							novy->Index=6;//upravy
							EngMapa->Mapa[x+y*sx].Spojak->Delete();
							EngMapa->Mapa[x+y*sx].Spojak->Add(novy);
							EngSStrely->Delete();//smazat tu strelu
							}
						break;
						}
					}
				}
			if(hr=S_OK)
				break;//strela znicena
			}
		if(hr=S_OK)
			break;//strela znicena
		}//do del at, ze strela znici tolikobjektu, kolik v jednom frame zasahne
		//a ne jen ten jeden na kterynarazila prvni
		//prestoze by v dosahu byly dalsi objekty
	if(hr!=S_OK)//strela nebyla znicena vybuchem
		if(strela->Dolet<0)//opusteni mapky DEMO nevadi
			{//strele vyprsela zivotnost
			EngSStrely->Delete();
			//nebo vyletla  mapky
			//do del at zruseni strely
			}
	}*/
return S_OK;
}//totalne predelat

HRESULT SetVisible()
{
D3DVECTOR Roh[4];
float RohX[4];//souradnice (mapkove) pruseciku s mapkou
float RohY[4];
float FOVh=ProjFOV/2;
float FOVw=FOVh/ProjAspect;
Roh[0]=D3DVECTOR(-FOVw,FOVh,1);
Roh[1]=D3DVECTOR(FOVw,FOVh,1);
Roh[2]=D3DVECTOR(-FOVw,-FOVh,1);
Roh[3]=D3DVECTOR(FOVw,-FOVh,1);
for(int i=0;i<4;i++)
	{
	D3DMath_VectorMatrixMultiply(Roh[i],Roh[i],matViewInvert);
	Roh[i]-=vEyePt;
	}
//prusecik primky vedouci bodem D3DVECTOR vEyePt;
//smerem Roh 0..3 s rovinou x,z
for(i=0;i<4;i++)
	{
	RohX[i]=-(vEyePt.y/Roh[i].y)*Roh[i].x+vEyePt.x;
	RohY[i]=(vEyePt.y/Roh[i].y)*Roh[i].z-vEyePt.z;
	}
MapVisibleFromX=(int)getmin(RohX,4)-1;//i radu tesne vedle (muze zasahovat nejaky staticky objekt)
MapVisibleFromY=(int)getmin(RohY,4)-1;
MapVisibleToX=(int)getmax(RohX,4)+1;
MapVisibleToY=(int)getmax(RohY,4)+1;
if(MapVisibleFromX<=0)MapVisibleFromX--;
if(MapVisibleFromY<=0)MapVisibleFromY--;//protoze se to zaokrouhluje na druhou stranu
return S_OK;//porad trochu nepresne (mozna to dela directx???)
//dodelat .... jsou tu nejake nepresnosti ve vypoctech?!?!?!?
//ze by ta 'inverzni' matice nebyla az tak inverzni??!?!?!
}

/**********RenderGame************************/

HRESULT RenderGame(LPDIRECT3DDEVICE3 pd3dDevice,LPDIRECT3DVIEWPORT3 pvViewport, D3DRECT* prcViewRect,DWORD ftime)
{
if(FAILED(RenderMap(pd3dDevice,pvViewport,prcViewRect,ftime)))
	return E_FAIL;
// render players
pd3dDeviceCB=pd3dDevice;
if(FAILED(DPlayEnumPlayers(NULL, RenderPlayerCB, NULL, 0)))
	{
	ShowError(IDS_DPLAY_ERROR_EP);
	return E_FAIL;
	}
if(gbRadar)
	if(FAILED(RenderRadar(pd3dDevice,pvViewport,prcViewRect,ftime)))
		return E_FAIL;
return S_OK;
}//nove zruseno


HRESULT VeVode(float x,float y)//zjisti zda se tento bod podle mapky nachazi ve vode
{
int mx=(int)floor(x);
int my=(int)floor(y);
x-=(float)mx;
y-=(float)my;
if(mx<0||my<0||mx>=EngMapa->SizeX||my>=EngMapa->SizeY)
	return S_OK;//jsem mimo mapku -> ve vode
switch(EngMapa->Mapa[mx+my*EngMapa->SizeX].Podklad)
	{//podle podkladu
	case 0:
		return S_OK;
	case 1:
		return E_FAIL;
/*************************/
	case 2:
		if(y>0.5f)return S_OK;
		break;
	case 3:
		if(x>0.5f)return S_OK;
		break;
	case 4:
		if(y<0.5f)return S_OK;
		break;
	case 5:
		if(x<0.5f)return S_OK;
		break;
/*************************/
	case 6:
		if(x+y>0.5f)return S_OK;
		break;
	case 7:
		if(x+(1.0f-y)>0.5f)return S_OK;
		break;
	case 8:
		if((1.0f-x)+(1.0f-y)>0.5f)return S_OK;
		break;
	case 9:
		if((1.0f-x)+y>0.5f)return S_OK;
		break;
/*************************/
	case 10:
		if((1.0f-x)+(1.0f-y)<0.5f)return S_OK;
		break;
	case 11:
		if((1.0f-x)+y<0.5f)return S_OK;
		break;
	case 12:
		if(x+y<0.5f)return S_OK;
		break;
	case 13:
		if(x+(1.0f-y)<0.5f)return S_OK;
		break;
	default:
		return E_FAIL;
	}
return E_FAIL;
}


/********dynamicke zmeny mapky******************/

/*void PridejZmenu(TZmena *zmena)
{
EngDynam->Add(zmena);
if(EngNearestTime>zmena->intime)
	EngNearestTime=zmena->intime;
}*///nove zruseno



/*void FireStrela()
{//DEMO
if(EngActCar)//moje auto na scene
	{//pridej strelu do seznamu leticich strel
	TStrela *temp=new TStrela;
	if(!temp)
		return;//problem s pameti
	temp->Typ=0;//0obyc 1raketa 2granat
	temp->Vyska=0;//0pozemni 1vzdusna
	temp->X=EngActCar->X;//aktualni pozice
	temp->Y=EngActCar->Y;
	temp->Dolet=20.0;//kolik ji zbyva uletet (doladit)
	temp->dX=(float)cos(EngActCar->R)*3.0f;//doladit
	temp->dY=(float)sin(EngActCar->R)*3.0f;
	EngSStrely->Add(temp);
	}//do de la t ruzne typy strel
}*///nove zruseno


void AddTextInfo(char *str)
{
TText *nove=new TText;
nove->data=new char[strlen(str)+1];
strcpy(nove->data,str);
TextInfo.Add(nove);//a je to
}

void ClearTextInfo()
{
TextInfo.DeleteAll();
}


void SetStartPosition(SHIP *ship)
{
//zaroven odstartujeme pocitadlo casu na bojisti (kvuli moznosti vratit se zpet do bunkru)
gBitkaTime=0;
//***************
int nasel=0;
ship->X=0;
ship->Y=0;
for(int y=0;y<EngMapa->SizeY;y++)
for(int x=0;x<EngMapa->SizeX;x++)
	{
	if(EngMapa->Mapa[x+y*EngMapa->SizeX].Podklad==14)
		nasel++;//mam zakladnu
	if(nasel==ship->byType+1)
		{
		ship->X=(float)x+0.5f;
		ship->Y=(float)y+0.5f;
		basekaX=(float)x+0.5f;
		basekaY=(float)y+0.5f;
		return;
		}
	}//ted uz i staticke objekty na mapce
}

void SetStartGlobPos()//musi uz byt naplnene EngDruzstvo a EndMapa
{
int nasel=0;
for(int y=0;y<EngMapa->SizeY;y++)
for(int x=0;x<EngMapa->SizeX;x++)
	{
	if(EngMapa->Mapa[x+y*EngMapa->SizeX].Podklad==14)
		nasel++;//mam zakladnu
	if(nasel==EngDruzstvo+1)
		{
		GlobX=(float)x+0.5f;
		GlobY=(float)y+0.5f;
		return;
		}
	}//ted uz i staticke objekty na mapce
}

void ChangeZbran()
{
SHIP ship;
DWORD dwSize = sizeof(ship);
HRESULT hr = DPlayGetPlayerData(gOurID, &ship, &dwSize, DPGET_LOCAL);
if (FAILED(hr))
	return;//nema to cenu
switch(ship.Typ)
	{
	case 0:
	break;//neni co menit
	case 1:
	break;//taky neni co menit
	case 2:
	EngActZbran=!EngActZbran;
	break;
	case 3:
	EngActZbran=!EngActZbran;
	break;
	}
}

/*HRESULT GetMyDruzstvo(int &skup)
{//nepodporuje UNICODE !!!!!!! -> nepouzivat UNICODE
char *name;
DWORD dwDataSize=0;
HRESULT hr = DPlayGetPlayerName(gOurID, NULL, &dwDataSize);
if(FAILED(hr)&&hr!=DPERR_BUFFERTOOSMALL)
	return hr;
name = (char *)GlobalAllocPtr(GHND, dwDataSize);
if (name == NULL)
	return (DPERR_NOMEMORY);
hr = DPlayGetPlayerName(gOurID, name, &dwDataSize);
if(FAILED(hr))
	return hr;
if(name[0]=='0')
	{
	skup=0;
	GlobalFreePtr(name);
	return S_OK;
	}
else if(name[0]=='1')
	{
	skup=1;
	GlobalFreePtr(name);
	return S_OK;
	}
GlobalFreePtr(name);
return E_FAIL;
}*/