#include "dsutil.h"
#include "dsnd.h"
#include "main.h"

LPDIRECTSOUND           lpDS;
HSNDOBJ                 hsoBeginLevel     = NULL;
HSNDOBJ                 hsoExplode     = NULL;
HSNDOBJ                 hsoGunShot     = NULL;

//playpanned dodelat (podobne jako tohle)
//zatim to necham mono (ale format vystupu necham default (takze mozna stereo))
//coz je zbytecne, casem upravit?!??!

BOOL SndObjFreq(SNDOBJ *pSO,DWORD freq)
{
    int i;

    if (pSO == NULL)
		return FALSE;

//pouziti freq omezit na rozsah 8000-44100 Hz, kvuli hardwarovemu mixovani
	if(freq<8000)
		freq=8000;
	else if(freq>44100)
		freq=44100;

    for (i=0; i<pSO->iAlloc; i++)
    {
	if(FAILED((pSO->Buffers[i])->lpVtbl->SetFrequency(pSO->Buffers[i],freq)))
		return FALSE;
    }

    return TRUE;
}


void InitializeSound( void )
{
	if(!bWantSound)
		return; // out of here
    bSoundEnabled = FALSE;
    if (SUCCEEDED(DirectSoundCreate(NULL, &lpDS, NULL)))
    {
        if (SUCCEEDED(lpDS->lpVtbl->SetCooperativeLevel(lpDS, hWndMain,
            DSSCL_NORMAL)))
        {
            hsoBeginLevel     = SndObjCreate(lpDS, "BeginLevel",      1);
            hsoExplode     = SndObjCreate(lpDS, "Explode",      1);
            hsoGunShot     = SndObjCreate(lpDS, "GunShot",      1);
            bSoundEnabled = TRUE;

//#ifdef USE_DSOUND   this should be dead code Josephc
/*            if( bPlayIdle )
                SndObjPlay(hsoEngineIdle, DSBPLAY_LOOPING);

            if( bPlayBuzz )
                SndObjPlay(hsoShieldBuzz, DSBPLAY_LOOPING);

            if( bPlayRev )
                SndObjPlay(hsoEngineRev, DSBPLAY_LOOPING);*/
//#endif
        }
        else
        {
            lpDS->lpVtbl->Release(lpDS);
            lpDS = NULL;
        }
    }
}

void DestroySound( void )
{
	if(!bWantSound)
		return; //No work to be done
    bSoundEnabled = FALSE;
    if (lpDS)
    {
        SndObjDestroy(hsoBeginLevel);
        hsoBeginLevel = NULL;
        SndObjDestroy(hsoExplode);
        hsoExplode = NULL;
        SndObjDestroy(hsoGunShot);
        hsoGunShot = NULL;
/*        SndObjDestroy(hsoEngineIdle);
        hsoEngineIdle = NULL;
        SndObjDestroy(hsoEngineRev);
        hsoEngineRev = NULL;
        SndObjDestroy(hsoSkidToStop);
        hsoSkidToStop = NULL;
        SndObjDestroy(hsoShieldBuzz);
        hsoShieldBuzz = NULL;
        SndObjDestroy(hsoShipExplode);
        hsoShipExplode = NULL;
        SndObjDestroy(hsoFireBullet);
        hsoFireBullet = NULL;
        SndObjDestroy(hsoShipBounce);
        hsoShipBounce = NULL;
        SndObjDestroy(hsoDonutExplode);
        hsoDonutExplode = NULL;
        SndObjDestroy(hsoPyramidExplode);
        hsoPyramidExplode = NULL;
        SndObjDestroy(hsoCubeExplode);
        hsoCubeExplode = NULL;
        SndObjDestroy(hsoSphereExplode);
        hsoSphereExplode = NULL;*/

        lpDS->lpVtbl->Release(lpDS);
        lpDS = NULL;
    }
}
