/*==========================================================================
 *
 *  Copyright (C) 1995-1997 Microsoft Corporation. All Rights Reserved.
 *
 *  File:       input.h
 *
 *
 ***************************************************************************/

#ifndef _INPUT_H
#define _INPUT_H

#include <dinput.h>

//--------------------------------------------------------------------------


// keyboard buffer size
#define KEYBUFSIZE 32

/*
 * keyboard commands
 */
/*#define KEY_STOP   0x00000001l
#define KEY_DOWN   0x00000002l
#define KEY_LEFT   0x00000004l
#define KEY_RIGHT  0x00000008l
#define KEY_UP     0x00000010l
#define KEY_FIRE   0x00000020l
#define KEY_THROW  0x00000040l
#define KEY_SHIELD 0x00000080l*///nove predelavam
#define KEY_LEFT    0x00000001l//ok
#define KEY_RIGHT   0x00000002l//ok
#define KEY_FRONT   0x00000004l//ok
#define KEY_BACK    0x00000008l//ok
#define KEY_SPLEFT  0x00000010l//ok
#define KEY_SPRIGHT 0x00000020l//ok
#define KEY_FIRE1   0x00000040l//ok
#define KEY_FIRE2   0x00000080l//ok

//--------------------------------------------------------------------------

// external variables
extern BOOL bKeyboardAcquired;
//extern HWND hWndMain;


//--------------------------------------------------------------------------


// prototypes
#ifdef __cplusplus
extern "C" {
#endif
/********C/C++*************/
extern DWORD (*ReadGameInput)(void);

BOOL InitInput(HINSTANCE hInst, HWND hWnd);
void CleanupInput(void);
BOOL ReacquireInput(void);
BOOL PickInputDevice(int);

/********C/C++*************/
#ifdef __cplusplus
}
#endif


//--------------------------------------------------------------------------
#endif // _INPUT_H









