#if !defined(FVUJ__RENDER_H)
#define FVUJ__RENDER_H

#include <d3d.h>
#include "dplay\comm.h"
#include "btkclass.h"

#ifdef __cplusplus
extern "C" {
#endif

extern SHIP PlayerBuf[MAX_PLAYERS];
extern DPID PlayerPID[MAX_PLAYERS];
extern int PlayerCount;

struct TCamera{
float cilX;
float cilY;
float cilZ;//v hernich souradnicich
float maxrych;
};

extern LPDIRECT3DMATERIAL3 g_pmtrlObjectMtrl;
extern D3DVECTOR vEyePt;
extern D3DVECTOR vLookatPt;
extern D3DVECTOR vUpVec;
extern D3DMATRIX matWorld, matView, matProj,matProj2,matViewInvert;
extern TCamera EngCam;

extern BOOL g_bWindowed;

extern float ProjFOV;
extern float ProjAspect;//nastavuje deviceinit

extern int MapVisibleFromX;
extern int MapVisibleFromY;
extern int MapVisibleToX;
extern int MapVisibleToY;//tyto polozky vyplni fce SetVisible();


extern int EngAppState;
//0..start aplikace
//1..aktivni hra, auto na bojisti
//2..aktivni hra, hrac v bunkru

//prototypy
CHAR*   PromptUserForFileToLoad( HWND );

#ifdef __cplusplus
}
#endif



#endif